# version avec => au lieu de <=> dans les points fixes

import os
#from bvadhoc import *
#import transformation

# On a ici les classes pour l'AST d'une formule.

# Les classes de formules servent a la fois a manipuler des formules QCTL,
# et a manipuler les formules de QBF qu'on soumettra a Z3,
# sachant que QBF est inclus dans QCTL.

# La methode toString d'une formule permet ainsi d'obtenir,
# si cette formule est dans QBF, sa representation en forme prefixe
# particuliere a Z3.

# On donne aussi une methode toString aux formules qui ne sont pas dans QBF
# pour faciliter le debug.

# La methode write ecrit la representation d'une formule QBF dans un fichier.
# Elle est plus efficace que toString, qui fait des additions (couteuses) de string.

# la methode nbalt renvoie le nb d'alternation E/A ou A/E. La var t sert a indiquer si on est dans un E (0) ou dans A (1), ou dans du Boolean (None)

# PropQuant renvoie la liste des var introduites par Exists/Forall et celle introduite par Exists1/Forall1
# (pas le meme traitement dans transformation 5)

# La methode MaPl (mise a plat) renvoie une formule de la forme suivante si niv==-1 :
# [Q] Exists q1...qk . Phi1 ^ AG (q1 <=> def1) ^... ^AG (qk <=> defk)
# ou Phi1 et les def_i sont de heuteur temporelle 1 [les def_i ont meme un op temporel a la racine]
# et [Q] est le bloc de quantificateurs initial (forme normale prenex).
# si on l'appelle avec niv=0, on obtient:
# [Q] Phi1
# dans ce dernier cas, les def_i sont a recuperer dans les parametres D et Df.
# Et c'est ce qu'on utilise pour coder vers z3...
# On utilise un entier justeX pour ne garder dans Phi1 que une hauteur de EX/AX/AG de 1, et
# pas de U: c'est pour homogeneiser le codage z3 -> remplace' par un entier: 0 (on met tout), 1 (juste EX/AX/AG), 2  (EX/AX/AG/EF)
# et avec 3 (utilise' pour QCIR3=PNF2) on laisse EX/AX/AG/EF/EU/AU/AF (car les ppf ont un traitement couteux dans le cas general que l'on
# peut simplifier pour Phi_1

# La methode AGFlat2QBF est utilisee pour coder les ssf AG(p <=> def) ou def est une formule CTL de HT <=1.
# Elle renvoie une liste de termes (conjonctions) representant la reduction.
# La methode FFlat2z3 sert a` coder une formule depuis un etat s. Elle est utilisee depuis AGFlat2QBF
# et depuis transformation5 pour la formule CTL "principale" (sans les AG(p <=> def) )


# toQBF transforme une formule QCTL contenant des EX, AX, EF et AG en une formule de QBF.

# FNN(true,_) = pour propager un Non... et obtenir une FNN.
# FNN(False,_) = pour ne pas propager un Non... (et obtenir une FNN).
# FNN(_,opeq) = laisse les op EQ si opeq est a vrai (pour UU... et Z3)
# (le second argument sert a` coder l'ex-fonction de nnf.py / mais il y a tout d ememe des diff : on ne laisse pas de NON (EQ (F1, F2)),
# mais on met EQ(NON F1, F2)


# FPT : FixedPoint Tranbsformation (method FP)
# -> replace every EU/AU/EW/AW/AF/EG by a fixedpoint def. (not EF and AG... the transformation does not simplify the formula)
# the resulting formula uses only Boolean comb, EX, AX, AG, EF, Exists, Forall...

# AjoutUniq
# ajoute des Uniq(p) pour les var p introduite par des Exists1 ou Forall1
# Lqv contient tous les Uniq a inserer dans le cas ou PNF est Vrai (on les
# insere pour respecter la forme Prenex supposee de la formule initiale)
    
count=0
cgate=0

def getIdent() :
    global count
    count+=1
    return "_k"+str(count)

def getIdentEA() :
    global count
    count+=1
    return "_u"+str(count)

def QIdent(s) :
        return "_q"+s[1:] 

def newGate() :
        global cgate
        cgate += 1
        return "g"+str(cgate)

def listevar(L,fout) :
    fst=True
    for p in L :
        if fst :
            fout.write(p)
            fst=False
        else :
            fout.write(","+p)
    
def Kripkestring_of_state(st) :
        ans=st[0]
        for c in st[1:] :
            ans=ans+"_"+c
        return ans
    

def isliteral(f) :
    if isinstance(f,AP) :
        return True
    elif isinstance(f,NOT) :
        aux =f.fils[0]
        return isinstance(aux,AP)
    else :
        return False

   
def switchSAlt(lq) :
    if lq==0 or lq==3 :
        return lq
    elif lq==1 :
        return 2
    else :
        return 1

# renvoie (uniq(pFA1) ^... ) => (Uniq(pEx1) ^... ^F)
def MiseEnFormeUniq(F,Lqv) :
    if len(Lqv)==0 :
        return F
    else :
        Lfa, Lex = [], []
        for u in Lqv :
            if u.forall :
                Lfa.append(u)
            else :
                Lex.append(u)
        if len(Lfa)==0 :
            Lex.append(F)
            return AND(Lex)
        else :
            if len(Lex)==0 :
                return IMPL(AND(Lfa),F)
            else :
                Lex.append(F)
                return IMPL(AND(Lfa),AND(Lex))

#####################################################################

            
######################################################################
# a tuple of parameters used for reduction to qbf 
# used for the result of Reduction (some lists are useful fir the next step to QBF
class RPARAM :
    def __init__(self,PropB=None,VarQone=None,PropBVpf=None) :
        if PropB==None :
            self.BQProp = []
        else : 
            self.BQProp = PropB
        if VarQone==None :
            self.QPropEA = []
        else : 
            self.QPropEA = VarQone
        if PropBVpf==None :
            self.BVQProppf=[]
        else : 
            self.BVQProppf = PropBVpf
        self.Kpf = 0
        self.Kea = 0
        self.method=''
        self.codageEA1=0

    def toString(self) :
        return "Parameters for reduction: "+str(self.Kpf)+" "+str(self.Kea)+" "+self.method+" "+str(self.codageEA1)+"\n"+"BQProp : "+str(self.BQProp)+"\n"+"QPropEA : "+str(self.QPropEA)+"\nPropBVpf : "+str(self.BVQProppf)+"\n"
      
###############################################################################
#                          AP
###############################################################################
class AP :
    def __init__(self, val) :
        self.fils=[]
        self.ap=val
       
    def toString(self) :
        return self.ap

    def SimplifB(self) :
        return AP(self.ap)

    def PropQuant(self) : 
        return ([],[],[])
    
    def write(self, output) :
        output.write(self.ap)

    # qblock = T ssi on est encore dans le bloc de quantif externe
    # ng = ?
    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        if not ng==None :
            print("Warning ! ng not defined in toQCIR for AP !")
        return self.ap

    def toZ3(self,fout) :
        fout.write(self.ap)
        
    def nbalt(self,t = None) :
        return 0

    def isPNF(self,niveau) :  # niveau = True si des quantif sont encore autorisees
        return True

    def MaPl(self,D,Df,niv,justeX =0) :   # retourne la formule mise a plat (de HT 1). D associe a une sous-form une chaine (le nom de la prop), niv=-1 sert a ajouter des Exists pour les formules de CTL, niv=0 (resp. 1) sert a indiquer la HT de la formule. 
        return AP(self.ap)

    def FPT(self) :
        return AP(self.ap)

    
    # ajoute des Uniq(p) pour les var p introduite par des Exists1 ou Forall1
    # Lqv contient tous les Uniq a inserer dans le cas ou PNF est Vrai (on les
    # insere pour respecter la forme Prenex supposee de la formule initiale)
    def AjoutUniq(self,PNF,Lqv) :
        if len(Lqv)==0 :
            return AP(self.ap)
        else :
            return MiseEnFormeUniq(self,Lqv)
        
    
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,AP(self.ap))
        else :
            return EXISTS(L,FORALL([p],AP(self.ap)))

# utilise pour ajouter une conjonction apres les quantif d'uen formule Prenex
    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)

    # QBvar = liste des var quantif  booleenees,
    # QBVvarpf = liste des var quantif BV pour les pts fixes (method FBV)
    # QBVvarea = liste des var quantif 
    def toQBF(self,rp,krip,s) :
        VarQ, VarQone, QBVvarpf, ku, kea, met, ea1 = rp.BQProp, rp.QPropEA, rp.BVQProppf, rp.Kpf, rp.Kea, rp.method, rp.codageEA1
#        (QBvar,QBVvarpf,QBVvarea,kBV) = VarQ
         
        if self.ap in VarQ :
            return AP(self.ap+"_"+Kripkestring_of_state(s))
        elif self.ap in VarQone :
            if ea1 != 3 and ea1 != 6 :
                return AP(self.ap+"_"+Kripkestring_of_state(s))
            else :   # BV
                # une formule = codage(ap)=codage(s)
                return BVcompEgalv(self.ap,krip.Numero(s),kea)
        elif self.ap in QBVvarpf :
            return BVcompInfv(self.ap+"_"+Kripkestring_of_state(s),krip.BUntilD(),ku)
        elif self.ap in krip.label[s] :
            return TOP()
        else :
            return BOTTOM()
    
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        (PropB, PropBV, PropQ1, PropQ1FA) = VarQ
        if self.ap in PropB :
            fout.write(" "+self.ap+"_"+Kripkestring_of_state(stp)+" ")
        elif self.ap in PropBV :
            fout.write(" (bvult "+self.ap+"_"+Kripkestring_of_state(stp)+" "+krip.cBUntil()+")")
        elif self.ap in PropQ1 :
            fout.write(" (= "+self.ap+" "+krip.cNumero(stp)+")")
        elif self.ap in krip.label[stp] :
            fout.write(" true ")
        else :
            fout.write(" false ")
        
    def FNN(self,np,opeq=False) : # mise sous forme normale negative, np=True ssi on propage un non
        if np :
            return NOT(AP(self.ap))
        else :
            return AP(self.ap)

    def Size(self,lq=0) : # return (t,ht,nba,nbqvar) : taille; the temporal height, the number of alternations, and the number of quantified var.
                        # lq = last quantifier: 0 no quant, 1 : exists, 2 : foral, 3 : "both" (ie on augmente le nba quel que soit le prochain)
        return (1,0,0,0)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return True

    def ContainsOP(self,L) :
        return (AP in L) 

    def TraitementEUAUAF(self,prop) :
        return  AP(self.ap)
        
###############################################################################
#                          UNIQ
###############################################################################
# sert a representer la macro Uniq qui peut se coder selon differentes strategies
# ap est le nom de la var qui doit etre unique, et forall est T ssi la var est liee a un Forall1
# (sinon c'est a`un Exists1)
class UNIQ :
    def __init__(self, val, typeea) :
        self.fils=[]
        self.ap=val
        self.forall=typeea
       
    def toString(self) :
        return "Uniq("+self.ap+")"

    def SimplifB(self) :
        return UNIQ(self.ap,self.forall)

    def PropQuant(self) : 
        return ([],[],[])
    
    def write(self, output) :
        print("Warning ! write is not yet defined for UNIQ !")
        output.write(self.ap)

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for UNIQ !")
        return self.ap

    def toZ3(self,fout) :
        print("Warning ! FFlat2z3 is not defined for UNIQ !")
        fout.write(" false ")

    def nbalt(self,t = None) :
        return 0

    def isPNF(self,niveau) :  # niveau = True si des quantif sont encore autorisees
        return True

    def MaPl(self,D,Df,niv,justeX =0) :   # retourne la formule mise a plat (de HT 1). D associe a une sous-form une chaine (le nom de la prop), niv=-1 sert a ajouter des Exists pour les formules de CTL, niv=0 (resp. 1) sert a indiquer la HT de la formule. 
        return UNIQ(self.ap,self.forall)

    def FPT(self) :
        return UNIQ(self.ap,self.forall)

    def AjoutUniq(self,PNF,Lqv) :
        print("Warning ! AjoutUniq shouldn't be called ocer a UNIQ formula.")
        return TOP()
    
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,UNIQ(self.ap,self.forall))
        else :
            return EXISTS(L,FORALL([p],UNIQ(self.ap,self.forall)))

# utilise pour ajouter une conjonction apres les quantif d'uen formule Prenex
    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)

    def toQBF(self,rp,krip,s) :
        VarQ, VarQone, QBVvarpf, ku, kea, met, ea1 = rp.BQProp, rp.QPropEA, rp.BVQProppf, rp.Kpf, rp.Kea, rp.method, rp.codageEA1
        #print("WARNING ! toQBF is not YET defined for UNIQ ! TO BE DONE !")
        # code for AP:
        if ea1 == 1 : #methode explicite !
            lor=[]
            for st in krip.accessibles[s] :
                fst = AP(self.ap)
                fnot = NOT(AP(self.ap))
                pst = fst.toQBF(rp,krip,st)
                land=[pst]
                for stp in krip.accessibles[st] :
                    if not stp==st :
                        land.append(fnot.toQBF(rp,krip,stp))
                lor.append(AND(land))
            return OR(lor)
        # to be done !
        elif ea1 == 2 :  #pt fixe
            paux = getIdentEA()
            Faux = AND([EF(AP(self.ap)),FORALL([paux],IMPL(EF(AND(AP(paux),AP(self.ap))),AG(IMPL(AP(self.ap),AP(paux)))))])
            VarQ.append(paux) # a VarQ !! 
#            print("1) Uniq to QBF: ",Faux.toString())
            Faux = Faux.toQBF(rp,krip,s)
 #           print("2) Uniq to QBF: ",Faux.toString())
            return Faux
        elif ea1 == 3 : # BitVec
            if not s==krip.start :
                print("Warning Uniq(",self.ap,") occurs outside the quantifiers block (encoded as EF)")
                Fef = EF(AP(self.ap)) 
                return Fef.toQBF(rp,krip,s)
            else :
                return BVcompInfEv(self.ap,len(krip.accessibles[krip.start])-1,kea)
        elif ea1==4 : # codage Ex1 comme "au plus une fois" avec quantif (comme 1)
            land=[]
            for st in krip.accessibles[s] :
                fst = AP(self.ap)
                fnot = NOT(AP(self.ap))
                pst = fst.toQBF(rp,krip,st)
                land2=[ ]
                for stp in krip.accessibles[st] :
                    if not stp==st :
                        land2.append(fnot.toQBF(rp,krip,stp))
                land.append(IMPL(pst,AND(land2)))
            return AND(land)
        elif ea1 == 5 : # codage Ex1 comme "au plus une fois" avec quantif (comme 2)
            paux = getIdentEA()
            Faux = FORALL([paux],IMPL(EF(AND(AP(paux),AP(self.ap))),AG(IMPL(AP(self.ap),AP(paux)))))
            VarQ.append(paux) # a VarQ !!   
            return Faux.toQBF(rp,krip,s)
        elif ea1 == 6 : # codage Ex1 comme "au plus une fois" avec BV (comme 3)
                return TOP() # everything is okay (the value may or may not correspond to some state)
        else :
            print("Warning ! Unknown case in Uniq.toQBF !")
            return TOP()
    
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        print("Warning ! FFlat2z3 is not defined for UNIQ !")
        fout.write(" false ")
        
    def FNN(self,np,opeq=False) : # mise sous forme normale negative, np=True ssi on propage un non
        if np :
            return NOT(UNIQ(self.ap,self.forall))
        else :
            return UNIQ(self.ap,self.forall)

    def Size(self,lq=0) : # return (ht,nba,nbqvar) : the temporal height, the number of alternations, and the number of quantified var.
                        # lq = last quantifier: 0 no quant, 1 : exists, 2 : foral, 3 : "both" (ie on augmente le nba quel que soit le prochain)
        return (1,0,0,0)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return True   # shouldn't be used...

    def ContainsOP(self,L) :
        return (UNIQ in L) 

    def TraitementEUAUAF(self,prop) :
        return  UNIQ(self.ap,self.forall)
    
###############################################################################
#                          BOTTOM
###############################################################################
# vrai
class BOTTOM :
    def __init__(self) :
        self.fils=[]

    def toString(self) :
        return "false"

    def SimplifB(self) :
        return BOTTOM()

    def PropQuant(self) : 
        return ([],[],[])

    def write(self, output) :
        output.write("false")

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        return 'gfalse'

    def toZ3(self,fout) :
        fout.write(" false ")

    def nbalt(self,t = None) :
        return 0

    def isPNF(self,niveau) :
        return True
    
    def MaPl(self,D,Df,niv,justeX = 0) : 
        return BOTTOM()

    def AjoutUniq(self,PNF,Lqv) :
        if len(Lqv)==0 :
            return BOTTOM()
        else :
            return MiseEnFormeUniq(self,Lqv)
        
    def FPT(self) :
        return BOTTOM()
    
    def AjoutListConj(self,Lc) :
        return BOTTOM()
 
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def toQBF(self,rp,krip,s) :
        return BOTTOM()

    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        fout.write(" false ")
        
    def FNN(self,np,opeq=False) :
        if np :
            return TOP()
        else :
            return BOTTOM()

    def Size(self,lq=0) : # return (ht,nba,nbqvar) 
        return (1,0,0,0)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return True

    def ContainsOP(self,L) :
        return (BOTTOM in L)

    def TraitementEUAUAF(self,prop) :
        return  BOTTOM()
    
###############################################################################
#                          TOP
###############################################################################
class TOP :
    def __init__(self) :
        self.fils=[]


    def toString(self) :
        return "true"

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        return 'gtrue'

    def toZ3(self,fout) :
        fout.write(" true ")

    def SimplifB(self) :
        return TOP()

    def PropQuant(self) : 
        return ([],[],[])
    
    def write(self, output) :
        output.write("true")

    def nbalt(self,t = None) :
        return 0

    def isPNF(self,niveau) :
        return True
    
    def MaPl(self,D,Df,niv,justeX = 0) : 
        return TOP()

    def FPT(self) :
        return TOP()

    def AjoutUniq(self,PNF,Lqv) :
        if len(Lqv)==0 :
            return TOP()
        else :
            return MiseEnFormeUniq(self,Lqv)
  
    def AjoutListConj(self,Lc) :
        return AND(Lc)
 
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def toQBF(self,rp,krip,s) :
        return TOP()

    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        fout.write(" true ")
        
    def FNN(self,np,opeq=False) :
        if np :
            return BOTTOM()
        else :
            return TOP()

    def Size(self,lq=0) : # return (ht,nba,nbqvar) 
        return (1,0,0,0)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return True

    def ContainsOP(self,L) :
        return (TOP in L)

    def TraitementEUAUAF(self,prop) :
        return  TOP()
    
###############################################################################
#                          NOT
###############################################################################
class NOT :
    def __init__(self, a) :
        self.fils=[a]
    
    def toString(self) :
#        return "(not "+self.fils[0].toString()+")"
        return "! "+self.fils[0].toString()

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        if not ng==None :
            print("Warning ! ng is defined in toQCIR for NOT !")
        if not isliteral(self) :  # cela peut arriver quand une prop quantifiee est codee par une formule (met FBV)
            print("--> "+self.toString())
        assert(isliteral(self))
        return '-'+self.fils[0].ap

    def toZ3(self,fout) :
        fout.write("(not ")
        self.fils[0].toZ3(fout)
        fout.write(")")

    def SimplifB(self) :
        aux=self.fils[0].SimplifB()
        if isinstance(aux,NOT) :
            return aux.fils[0]
        elif isinstance(aux,TOP) :
            return BOTTOM()
        elif isinstance(aux,BOTTOM) :
            return TOP()
        else :
            return (NOT(aux))

    def PropQuant(self) :
        return self.fils[0].PropQuant()
    
    def write(self, output) :
        output.write("(not ")
        self.fils[0].write(output)
        output.write(")")

    def nbalt(self,t = None) :
        return self.fils[0].nbalt(t)

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(niveau)
    
    def MaPl(self,D,Df,niv,justeX =0) :
        aux = self.fils[0]
        if not isinstance(aux,AP) : 
            print("Warning ! Dans Mise-a-plat : formule non mise en FNN ! (NOT)")
        return (NOT(self.fils[0].MaPl(D,Df,niv,justeX)))

    def FPT(self) :
        return NOT(self.fils[0].FPT())

    def AjoutUniq(self,PNF,Lqv) :
        if PNF and len(Lqv)==0 :
            return NOT(self.fils[0])
        elif PNF:
            return MiseEnFormeUniq(self,Lqv)
        else :
            return NOT(self.fils[0].AjoutUniq(PNF,Lqv))
 
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)
    
    def toQBF(self,rp,krip,s) :
        f=self.fils[0].toQBF(rp,krip,s)
        if not isinstance(f,AP) :
            f=f.FNN(True,False)
            return f
        return NOT(f)
    
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        fout.write("(not ")
        self.fils[0].FFlat2z3(VarQ,krip,stp,fout,D)
        fout.write(")")
        
    def FNN(self,np,opeq=False) : 
        return self.fils[0].FNN(not np,opeq)


    def Size(self,lq=0) : # return (t,ht,nba,nbqvar)
        (t,ht,nba,nbqvar) = self.fils[0].Size(switchSAlt(lq))
        return (t+1,ht,nba,nbqvar)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return self.fils[0].isCBEAXap(dejavuX)

    def ContainsOP(self,L) :
        if (NOT in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return  NOT(self.fils[0].TraitementEUAUAF(prop))
    
###############################################################################
#                          AND
###############################################################################
# Le 'et' et 'ou' de z3 prennent un nombre variable d'arguments.
# On definit donc un ET et un OU qui on un nombre variable de fils.
class AND :

    def __init__(self, lf1, f2 = None) :
        if f2==None :   # 1 argument
            self.fils=lf1
        else :     # 2 arguments (ex AND)
            self.fils=[lf1,f2]

    
    def toString(self) :
        if len(self.fils) == 0 :
            print("Warning ! Empty AND !")
            return "true"
        ans="("+self.fils[0].toString()
        for f in self.fils[1:] :
            ans=ans+" & "+f.toString()
        return ans+")"
        # ans=""
        # for f in self.fils :
        #     ans=ans+" "+f.toString()
        # return "(and "+ans+")"

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        if ng==None :
            ngate = newGate()
        else :
            ngate=ng
        Llit=[]
        for f in self.fils :
                Llit.append(f.toQCIR(gatestab,fout))
        fout.write(ngate+'= and(')
        listevar(Llit,fout)
        fout.write(')\n')
        return ngate

    def toZ3(self,fout) :
        fout.write("(and")
        for f in self.fils :
            fout.write(" ")
            f.toZ3(fout)
        fout.write(")")
        
    def SimplifB(self) :
#        print("SB : AND ",self.toString())
        lres=[]
        Litp , Litn = [], []
        Lsuite, Larg = self.fils, []
        cont = True
        while cont :
            Larg, Lsuite = Lsuite, []
            cont = False
            for f in Larg :
                fs=f.SimplifB()
                if isinstance(fs,TOP) :
                     pass
                elif isinstance(fs,BOTTOM) :
                    return BOTTOM()
                elif isinstance(fs,AND) : 
                    Lsuite.extend(fs.fils)
                    cont=True
                elif isliteral(fs) :
                    if isinstance(fs,AP) :
                      prop=fs.ap
                      Litp.append(prop)
                      if prop in Litn :
                        return BOTTOM()
                      else :
                        lres.append(fs)
                    else :
                        prop = fs.fils[0].ap
                        Litn.append(prop)
                        if prop in Litp :
                            return BOTTOM()
                        else :
                            lres.append(fs)
                else :
                    lres.append(fs)
#        print("SB : AND ",len(lres))
        if len(lres)==0 :
            return TOP()
        elif len(lres)==1 :
            return lres[0]
        else :
            return AND(lres)

    def PropQuant(self) : 
        lres,lres1,lres2=[],[],[]
        for f in self.fils :
            (L,L1,L2) = f.PropQuant()
            lres.extend(L)
            lres1.extend(L1)
            lres2.extend(L2)
        return (lres,lres1,lres2)

    
    def write(self, output) :
        output.write("(and")
        for f in self.fils :
            output.write(" ")
            f.write(output)
        output.write(")")

    def nbalt(self,t = None) :
        res = 0
        for f in self.fils :
            res = max(res,f.nbalt(t))
        return res

    def isPNF(self,niveau) :
        for f in self.fils :
            if not f.isPNF(niveau) :
                return False
        return True

    def MaPl(self,D,Df,niv,justeX =0) :
        lres=[]
        for f in self.fils :
            lres.append(f.MaPl(D,Df,max(0,niv),justeX))
        if niv==-1 : # on doit ajouter le bloc Exists
            return AuxMaPl(AND(lres),D,Df)
        return AND(lres)

    def FPT(self) :
        lres=[]
        for f in self.fils :
            lres.append(f.FPT())
        return AND(lres)

    def AjoutUniq(self,PNF,Lqv) :
        if PNF and len(Lqv)==0 :
            return AND(self.fils)
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else :
            Lres=[]
            for f in self.fils :
                aux = f.AjoutUniq(PNF,Lqv)
                Lres.append(aux)
            return AND(Lres)

    def AjoutListConj(self,Lc) :
        Lc.extend(self.fils)
        return AND(Lc)
 
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def toQBF(self,rp,krip,s) :
        L=[]
        for f in self.fils :
            L.append(f.toQBF(rp,krip,s))
        return AND(L)
    
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        fout.write("(and ")
        for f in self.fils :
            f.FFlat2z3(VarQ,krip,stp,fout,D)
            fout.write(" ")
        fout.write(")")
        
    def FNN(self,np,opeq=False) :
        lres=[]
        for f in self.fils :
            lres.append(f.FNN(np,opeq))
        if np :
            return OR(lres)
        else :
            return AND(lres)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        t,ht,nba,nbqv = 0,0,0,0
        for f in self.fils :
            (t1,h1,nba1,nbv1) = f.Size(lq)
            t+=t1
            ht=max(h1,ht)
            nba=max(nba1,nba)
            nbqv+=nbv1
        return (t+1,ht,nba,nbqv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        for f in self.fils :
            if not f.isCBEAXap(dejavuX) :
                return False
        return True

    def ContainsOP(self,L) :
        if (AND in L) :
            return True
        for f in self.fils :
            if f.ContainsOP(L) :
                return True
        return False

    def TraitementEUAUAF(self,prop) :
        Lres=[]
        for f in self.fils :
            Lres.append(f.TraitementEUAUAF(prop))
        return  AND(Lres)
    
###############################################################################
#                          OR
###############################################################################
class OR :

    def __init__(self, lf1, f2 = None) :
        if f2==None :
            self.fils=lf1
        else :
            self.fils=[lf1,f2]

    def toString(self) :
        if len(self.fils) == 0 :
            print("Warning ! Empty OR !")
            return "false"
        ans="("+self.fils[0].toString()
        for f in self.fils[1:] :
            ans=ans+" | "+f.toString()
        return ans+")"
        # ans=""
        # for f in self.fils :
        #     ans=ans+" "+f.toString()
        # return "(or "+ans+")"

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        if ng==None : 
            ngate = newGate()
        else :
            ngate =ng
        Llit=[]
        for f in self.fils :
                Llit.append(f.toQCIR(gatestab,fout))
        fout.write(ngate+'= or(')
        listevar(Llit,fout)
        fout.write(')\n')
        return ngate

    def toZ3(self,fout) :
        fout.write("(or")
        for f in self.fils :
            fout.write(" ")
            f.toZ3(fout)
        fout.write(")")
        
    def SimplifB(self) :
#        print("SB : OR ",self.toString())
        Litp, Litn = [], []
        lres=[]
        Lsuite , Larg = self.fils, []
        cont = True 
        while cont :
            Largs, Lsuite = Lsuite, [] 
            cont = False
            for f in Largs :
                fs=f.SimplifB()
                if isinstance(fs,BOTTOM) :
                    pass
                elif isinstance(fs,TOP) :
                    return TOP()
                elif isinstance(fs,OR) :
                    Lsuite.extend(fs.fils)
                    cont = True
                elif isliteral(fs) :
                    if isinstance(fs,AP) :
                      prop=fs.ap
                      Litp.append(prop)
                      if prop in Litn :
                        return TOP()
                      else :
                        lres.append(fs)
                    else :
                        prop = fs.fils[0].ap
                        Litn.append(prop)
                        if prop in Litp :
                            return TOP()
                        else :
                            lres.append(fs)
                else : 
                    lres.append(fs)
#        print("SB : OR ",len(lres))
        if len(lres)==0 :
            return BOTTOM()
        elif len(lres)==1 :
            return lres[0]
        else :
            return OR(lres)

    def PropQuant(self) : 
        lres,lres1,lres2=[],[],[]
        for f in self.fils :
            (L,L1,L2) = f.PropQuant()
            lres.extend(L)
            lres1.extend(L1)
            lres2.extend(L2)
        return (lres,lres1,lres2)
    
    def write(self, output) :
        output.write("(or")
        for f in self.fils :
            output.write(" ")
            f.write(output)
        output.write(")")

    def nbalt(self,t = None) :
        res = 0
        for f in self.fils :
            res = max(res,f.nbalt(t))
        return res
    
    def isPNF(self,niveau) :
        for f in self.fils :
            if not f.isPNF(niveau) :
                return False
        return True
    
    def MaPl(self,D,Df,niv,justeX =0) :
        lres=[]
        for f in self.fils :
            lres.append(f.MaPl(D,Df,max(0,niv),justeX))
        if niv==-1 : # on doit ajouter le bloc Exists
            return AuxMaPl(OR(lres),D,Df)
        return OR(lres)

    def AjoutUniq(self,PNF,Lqv) :
        if PNF and len(Lqv)==0 :
            return OR(self.fils)
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else :
            Lres=[]
            for f in self.fils :
                aux = f.AjoutUniq(PNF,Lqv)
                Lres.append(aux)
            return OR(Lres)
  
    def FPT(self) :
        lres=[]
        for f in self.fils :
            lres.append(f.FPT())
        return OR(lres)
    
    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)
 
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def toQBF(self,rp,krip,s) :
        L=[]
        for f in self.fils :
            L.append(f.toQBF(rp,krip,s))
        return OR(L)
    
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        fout.write("(or ")
        for f in self.fils :
            f.FFlat2z3(VarQ,krip,stp,fout,D)
            fout.write(" ")
        fout.write(")")
    
    def FNN(self,np,opeq=False) :
        lres=[]
        for f in self.fils :
            lres.append(f.FNN(np,opeq))
        if np :
            return AND(lres)
        else :
            return OR(lres)
    
    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        t,ht,nba,nbqv = 0,0,0,0
        for f in self.fils :
            (t1,h1,nba1,nbv1) = f.Size(lq)
            t+=t1
            ht=max(h1,ht)
            nba=max(nba1,nba)
            nbqv+=nbv1
        return (t+1,ht,nba,nbqv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        for f in self.fils :
            if not f.isCBEAXap(dejavuX) :
                return False
        return True

    def ContainsOP(self,L) :
        if (OR in L) :
            return True
        for f in self.fils :
            if f.ContainsOP(L) :
                return True
        return False

    def TraitementEUAUAF(self,prop) :
        Lres=[]
        for f in self.fils :
            Lres.append(f.TraitementEUAUAF(prop))
        return  OR(Lres)

def fusionAND(f1, f2) :
    return AND(f1.fils+f2.fils)

def fusionOR(f1, f2) :
    return OR(f1.fils+f2.fils)



    
###############################################################################
#                          EQ
###############################################################################    
# Equivalence
class EQ :
    def __init__(self, a1, a2) :
        self.fils=[a1, a2]


    def toString(self) :
        return self.fils[0].toString()+" <-> "+self.fils[1].toString()
#        return "(= "+self.fils[0].toString()+" "+self.fils[1].toString()+")"

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
#        print("Warning ! <=> shouldn't occur in QCIR spec.")
        if ng==None :
            ngate = newGate()
        else :
            ngate = ng
        l1=self.fils[0].toQCIR(gatestab,fout)
        l2=self.fils[1].toQCIR(gatestab,fout)
        if isliteral(self.fils[0]) :
            nf1=self.fils[0].FNN(True)
            l1n=nf1.toQCIR(gatestab,fout)
            fout.write(ngate+'=ite('+l2+','+l1+','+l1n+')\n')
        else : # l1 est une gate 
            fout.write(ngate+'=ite('+l2+','+l1+', -'+l1+')\n')
        return ngate

    def toZ3(self,fout) :
        fout.write("(= ")
        self.fils[0].toZ3(fout)
        fout.write(" ")
        self.fils[1].toZ3(fout)
        fout.write(")")
    
    def SimplifB(self) :
#        print("SB : EQ ",self.toString())
        f1=self.fils[0].SimplifB()
        f2=self.fils[1].SimplifB()
#        print("SB : EQ ",f1.toString()," / ",f2.toString())
        if isinstance(f1,TOP) :
          return f2
        elif isinstance(f2,TOP) :
          return f1
        elif isinstance(f1,BOTTOM) :
          return f2.FNN(True) # on fait la negation (et on la propage)
        elif isinstance(f2,BOTTOM) :
          return f1.FNN(True)
        else :
          return EQ(f1,f2)

    def PropQuant(self) : 
        (L,L1,L2)=self.fils[0].PropQuant()
        (M,M1,M2)=self.fils[1].PropQuant()
        L.extend(M)
        L1.extend(M1)
        L2.extend(M2)
        return (L,L1,L2)
      
    def write(self, output) :
      output.write("(= ")
      self.fils[0].write(output)
      output.write(" ")
      self.fils[1].write(output)
      output.write(")")

    def nbalt(self,t = None) :
        if t==None :
            return max(self.fils[0].nbalt(t),self.fils[1].nbalt(t))
        else :
            return max(self.fils[0].nbalt(0),self.fils[1].nbalt(1),self.fils[0].nbalt(1),self.fils[1].nbalt(0))

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(niveau) and self.fils[1].isPNF(niveau)

    def MaPl(self,D,Df,niv,justeX =0) :
        print("Warning ! Mise-a-plat d'une formule qui n'est pas sous forme NN (EQ) !")
        f1=self.fils[0].MaPl(D,Df,max(0,niv),justeX)
        f2=self.fils[1].MaPl(D,Df,max(0,niv),justeX)
        if niv==-1 : # on doit ajouter le bloc Exists
            return AuxMaPl(EQ(f1,f2),D,Df)
        return EQ(f1,f2)

    def AjoutUniq(self,PNF,Lqv) :
        if PNF and len(Lqv)==0 :
            return EQ(self.fils[0],self.fils[1])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            f2 = self.fils[1].AjoutUniq(PNF,Lqv)
            return EQ(f1,f2) 
  
    def FPT(self) :
        return EQ(self.fils[0].FPT(),self.fils[1].FPT())
    
    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)

    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def toQBF(self,rp,krip,s) :
        return EQ(self.fils[0].toQBF(rp,krip,s), self.fils[1].toQBF(rp,krip,s))

    
    def FFlat2z3(self,VarQ,krip,stp,fout) :
        fout.write("(= "+self.fils[0].FFlat2z3(VarQ,krip,stp,fout)+" "+ self.fils[1].FFlat2z3(VarQ,krip,stp,fout)  +")")
        
    def FNN(self,np,opeq=False) :
        f1=self.fils[0].FNN(False,opeq)
        f1n=self.fils[0].FNN(True,opeq)
        f2=self.fils[1].FNN(False,opeq)
        f2n=self.fils[1].FNN(True,opeq)
        if opeq :  # laisser EQ si f1 et f2 sont des formules propo ! A faire
            if np :
                return EQ(f1n,f2)    # ou EQ(f1,f2n) ! 
            else :
                return EQ(f1,f2)
        else : # on supprime le EQ
            if np :
                return OR(AND(f1n,f2),AND(f1,f2n))
            else :
                return OR(AND(f1,f2),AND(f1n,f2n))

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(3)
        (t1,h1,nba1,nbv1) = self.fils[1].Size(3)
        ht=max(h1,ht)
        nba=max(nba1,nba)  
        nbqv+=nbv1
        return (t+t1+1,ht,nba,nbqv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        for f in self.fils :
            if not f.isCBEAXap(dejavuX) :
                return False
        return True

def ContainsOP(self,L) :
        if (EQ in L) :
            return True
        for f in self.fils :
            if f.ContainsOP(L) :
                return True
        return False

def TraitementEUAUAF(self,prop) :
        return EQ(self.fils[0].TraitementEUAUAF(prop),self.fils[0].TraitementEUAUAF(prop))
    
###############################################################################
#                          IMPL
###############################################################################        
class IMPL :
    def __init__(self, a1, a2) :
        self.fils=[a1, a2]

    def toString(self) :
        s1=self.fils[0].toString()
        s2=self.fils[1].toString()
        return s1+" => "+s2
#        return "(=> "+self.fils[0].toString()+" "+self.fils[1].toString()+")"

    def SimplifB(self) :
#        print("SB : =>",self.toString())
        f1=self.fils[0].SimplifB()
        f2=self.fils[1].SimplifB()
#        print("SB : =>",f1.toString()," / ",f2.toString())        
        if isinstance(f1,TOP) :
          return f2
        elif isinstance(f1,BOTTOM) :
          return TOP()
        elif isinstance(f2,TOP) :
          return TOP()
        elif isinstance(f2,BOTTOM) :
          return f1.FNN(True)
        else :
          return IMPL(f1,f2)

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        if ng==None :
            ngate = newGate()
        else :
            ngate = ng
        l1=self.fils[0].toQCIR(gatestab,fout)
        l2=self.fils[1].toQCIR(gatestab,fout)
        fout.write(ngate+'=ite('+l1+','+l2+',gtrue)\n')
        return ngate

    def toZ3(self,fout) :
        fout.write("(=> ")
        self.fils[0].toZ3(fout)
        fout.write(" ")
        self.fils[1].toZ3(fout)
        fout.write(")")
    
    def PropQuant(self) : 
        (L,L1,L2)=self.fils[0].PropQuant()
        (M,M1,M2)=self.fils[1].PropQuant()
        L.extend(M)
        L1.extend(M1)
        L2.extend(M2)
        return (L,L1,L2)
      
    def write(self, output) :
      output.write("(=> ")
      self.fils[0].write(output)
      output.write(" ")
      self.fils[1].write(output)
      output.write(")")

    def nbalt(self,t = None) :
        if t==None :
            return max(self.fils[0].nbalt(t),self.fils[1].nbalt(t))
        elif t==0 :
            return max(self.fils[0].nbalt(1),self.fils[1].nbalt(0))
        else :
            return max(self.fils[0].nbalt(0),self.fils[1].nbalt(1))
        return 0

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(niveau) and self.fils[1].isPNF(niveau)

    def MaPl(self,D,Df,niv,justeX =0) : 
        print("Warning ! Mise-a-plat d'une formule qui n'est pas sous forme NN (IMPL) !")
        f1=self.fils[0].MaPl(D,Df,max(0,niv),justeX)
        f2=self.fils[1].MaPl(D,Df,max(0,niv),justeX)
        if niv==-1 :
            return AuxMaPl(IMPL(f1,f2),D,Df)
        return IMPL(f1,f2)

    def AjoutUniq(self,PNF,Lqv) :
        if PNF and len(Lqv)==0 :
            return IMPL(self.fils[0],self.fils[1])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            f2 = self.fils[1].AjoutUniq(PNF,Lqv)
            return IMPL(f1,f2)
        
    def FPT(self) :
        return IMPL(self.fils[0].FPT(),self.fils[1].FPT())
    
    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)

    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def toQBF(self,rp,krip,s) :
        return IMPL(self.fils[0].toQBF(rp,krip,s), self.fils[1].toQBF(rp,krip,s))

    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        fout.write("(=> "+self.fils[0].FFlat2z3(rp,krip,stp,fout)+" "+ self.fils[1].FFlat2z3(VarQ,krip,stp,fout)  +")")
        
    def FNN(self,np,opeq=False) :
        f1=self.fils[0].FNN(not np)
        f2=self.fils[1].FNN(np)
        if np :
            return AND(f1,f2)
        else :
            if isliteral(self.fils[0]) :
                return IMPL(self.fils[0],f2)
            else : 
                return OR(f1,f2)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(switchSAlt(lq))
        (t1,h1,nba1,nbv1) = self.fils[1].Size(lq)
        ht=max(h1,ht)
        nba=max(nba1,nba)  
        nbqv+=nbv1
        return (t+t1+1,ht,nba,nbqv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        for f in self.fils :
            if not f.isCBEAXap(dejavuX) :
                return False
        return True

    def ContainsOP(self,L) :
        if (IMPL in L) :
            return True
        for f in self.fils :
            if f.ContainsOP(L) :
                return True
        return False

    def TraitementEUAUAF(self,prop) :
        return IMPL(self.fils[0].TraitementEUAUAF(prop),self.fils[0].TraitementEUAUAF(prop))

    
###############################################################################
#                          FORALL
###############################################################################
#on peut mettre plusieurs variables sur le meme
#quantificateur en z3.
class FORALL :
    def __init__(self, varList, a) :
        self.fils=[a]
        self.var=varList

    def toString(self) :
        if len(self.var)==0 :
            print("Warning ! Forall with an an empty list of var !")
            return self.fils[0].toString()
        ans='Al '+self.var[0]
        for v in self.var[1:] :
            ans=ans+" "+v
        return ans+"."+self.fils[0].toString()
        # ans=""
        # for v in self.var :
        #     ans=ans+"("+v+" Bool)"
        # return "(forall ("+ans+") "+self.fils[0].toString()+")"

    def SimplifB(self) :
        f1=self.fils[0].SimplifB()
        if isinstance(f1,FORALL) :
            f1.var.extend(self.var)
            return f1
        elif isinstance(f1,TOP) :
            return TOP()
        elif isinstance(f1,BOTTOM) :
            return BOTTOM()
        else : 
            return FORALL(self.var,f1)

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        if qblock :
            fout.write("forall( ")
            listevar(self.var,fout)
            fout.write(")\n")
            if isinstance(self.fils[0],FORALL) or isinstance(self.fils[0],FORALL1) or isinstance(self.fils[0],EXISTS) or isinstance(self.fils[0],EXISTS1) :
                self.fils[0].toQCIR(gatestab,fout,qblock)
            else :
                ngate = newGate()
                fout.write("output("+ngate+")\n")
                fout.write("gtrue = and()\n")
                fout.write("gfalse = or()\n")
                aux = self.fils[0].toQCIR(gatestab,fout,False,ngate)  # correction 4/12
                return ""
        else : # un quantificateur hors bloc initial (non Prenex)
            if ng==None :
                ngate=newGate()
            else :
                ngate=ng
            gaux=self.fils[0].toQCIR(gatestab,fout,qblock,None)
            fout.write(ngate+" = forall(")
            listevar(self.var,fout)
            fout.write(";"+gaux+")\n")
            return ngate

    def toZ3(self,fout) :
        fout.write("(forall (")
        for v in self.var :
            fout.write("(")
            fout.write(v)
            fout.write(" Bool)")
        fout.write(") ")
        self.fils[0].toZ3(fout)
        fout.write(")")
        
    def PropQuant(self) :
        (lres,lres1,lres2) = self.fils[0].PropQuant()
        L=self.var[:]
        lres.extend(L)
        return (lres,lres1,lres2)
    
    def write(self, output) :
        output.write("(forall (")
        for v in self.var :
            output.write("(")
            output.write(v)
            output.write(" Bool)")
        output.write(") ")
        self.fils[0].write(output)
        output.write(")")

    def nbalt(self,t = None) :
        if t==None :
            return self.fils[0].nbalt(1)
        elif t==0 :
            return 1+self.fils[0].nbalt(1)
        else :
            return self.fils[0].nbalt(1)

    def isPNF(self,niveau) :
        if not niveau :
            return False
        return self.fils[0].isPNF(niveau)
    
    def MaPl(self,D,Df,niv,justeX =0) :
        if (len(D) > 0) :
            print("Warning ! Mise-a-plat d'une formule qui n'est pas sous forme Prenex (FORALL) !")
        # if niv != -1 :
        #     print("Warning ! Mauvaise valeur pour init dans la mise a plat d'une formule (FORALL) !")
        return FORALL(self.var,self.fils[0].MaPl(D,Df,niv,justeX))
        # sf=self.fils[0]
        # if isinstance(sf,FORALL) or isinstance(sf,FORALL1) or isinstance(sf,EXISTS) or isinstance(sf,EXISTS) :
        #     aux = self.fils[0].MaPl(D,Df)
        # else :
        #     aux = sf.MaPl(D,Df)
        #     aux = AuxMaPl(aux,D,Df)
        # return FORALL(self.var,aux)

    def AjoutUniq(self,PNF,Lqv) :
        return FORALL(self.var,self.fils[0].AjoutUniq(PNF,Lqv))
        
    def FPT(self) :
        return FORALL(self.var,self.fils[0].FPT())
    
    def AjoutListConj(self,Lc) :
        aux = self.fils[0]
        return FORALL(self.var, aux.AjoutListConj(Lc))
 
    def AjoutPropQuant(self,L,p=None) :
        return FORALL(self.var,self.fils[0].AjoutPropQuant(L,p))

    def toQBF(self,rp,krip,s) :
        if len(self.var)==0 :
            self.fils[0].toQBF(rp,krip,s)
        VarQ, VarQone, QBVvarpf, ku, kea, met, ea1 = rp.BQProp, rp.QPropEA, rp.BVQProppf, rp.Kpf, rp.Kea, rp.method, rp.codageEA1
        Lv = []
        for v in self.var :
            if (ea1 == 3 or ea1==6) and v in VarQone :   # BitVec !
                laux = BVgeneBV(v,kea)
                Lv.extend(laux)
            else :
                for st in krip.accessibles[s] :
                    if v in QBVvarpf  :  # BitVec too
                        aux=v+"_"+Kripkestring_of_state(st)
                        laux = BVgeneBV(v,ku)
                        Lv.extend(laux)
                    else :
                        Lv.append(v+"_"+Kripkestring_of_state(st))
        return FORALL(Lv,self.fils[0].toQBF(rp,krip,s))

    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        if (not stp == krip.start) :
            print("Warning ! FFlat2z3 - FORALL : pb d'arguments !")
        if len(self.var)==0 :
            self.fils[0].FFlat2z3(VarQ,krip,stp,fout,D)
        (PropB, PropBV, PropQ1, PropQ1FA) = VarQ
        fout.write("(forall (")
        for v in self.var :
            if v in PropB :
                for s in krip.accessibles[stp] : 
                    fout.write("("+v+"_"+Kripkestring_of_state(s)+" Bool)")
            elif v in PropBV :
                for s in krip.accessibles[stp] : 
                    fout.write("("+v+"_"+Kripkestring_of_state(s)+" (_ BitVec "+str(krip.TBVU)+"))")
            else :
                print("Cas bizarre dans FFlat2z3 - FORALL !")
        fout.write(")")
        self.fils[0].FFlat2z3(VarQ,krip,stp,fout,D)
        fout.write(")")
        
        
    def FNN(self,np,opeq=False) :
        f=self.fils[0].FNN(np,opeq)
        if np :
            return EXISTS(self.var,f)
        else :
            return FORALL(self.var,f)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(2)
        if lq==1 or lq==3 :
            nba+=1
        lv = len(self.var)
        return (t+lv,ht,nba,nbqv+lv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (FORALL in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return FORALL(self.var[:],self.fils[0].TraitementEUAUAF(prop))

###############################################################################
#                          FORALL1
###############################################################################
class FORALL1 :
    def __init__(self, varList, a) :
        self.fils=[a]
        self.var=varList

    def toString(self) :
        if len(self.var)==0 :
            print("Warning ! Forall1 with an an empty list of var !")
            return self.fils[0].toString()
        ans='Al1 '+self.var[0]
        for v in self.var[1:] :
            ans=ans+" "+v
        return ans+"."+self.fils[0].toString()
        # ans=""
        # for v in self.var :
        #     ans=ans+"("+v+" Bool)"
        # return "(forall1 ("+ans+") "+self.fils[0].toString()+")"

    def SimplifB(self) :
        f1=self.fils[0].SimplifB()
        if isinstance(f1,FORALL1) :
            f1.var.extend(self.var)
            return f1
        elif isinstance(f1,TOP) :
            return TOP()
        elif isinstance(f1,BOTTOM) :
            return BOTTOM()
        else : 
            return FORALL1(self.var,f1)

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR not defined for FORALL1 ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for FORALL1 ! ")
            
        fout.write("(forall (")
        for v in self.var :
            fout.write("(")
            fout.write(v)
            fout.write(" Bool)")
        fout.write(") ")
        self.fils[0].write(fout)
        fout.write(")")
        
    def PropQuant(self) : 
        (lres,lres1,lres2) = self.fils[0].PropQuant()
        L=self.var[:]
        lres1.extend(L[:])
        lres2.extend(L)
        return (lres,lres1,lres2)
    
    def write(self, output) :
        print('ne devrait pas passer par ici ! FORALL1:write !')
        output.write("(forall (")
        for v in self.var :
            output.write("(")
            output.write(v)
            output.write(" Bool)")
        output.write(") ")
        self.fils[0].write(output)
        output.write(")")

    def nbalt(self,t = None) :
        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
        return 0
       
    def isPNF(self,niveau) :
        if not niveau :
            return False
        return self.fils[0].isPNF(niveau)
    
    def MaPl(self,D,Df,niv,justeX =0) :
        if (len(D) > 0) :
            print("Warning ! Mise-a-plat d'une formule qui n'est pas sous forme Prenex (FORALL1) !")
        # if niv != -1 :
        #     print("Warning ! Mauvaise valeur pour init dans la mise a plat d'une formule (FORALL1) !")
        return FORALL1(self.var,self.fils[0].MaPl(D,Df,niv,justeX))
    
        # if (len(D) > 0)  :
        #     print("Warning ! Mise-a-plat d'une formule qui n'est pas sous forme Prenex (FORALL1) !")
        # sf=self.fils[0]
        # if isinstance(sf,FORALL) or isinstance(sf,FORALL1) or isinstance(sf,EXISTS) or isinstance(sf,EXISTS) : 
        #     aux = self.fils[0].MaPl(D,Df)
        # else :
        #     aux = sf.MaPl(D,Df)
        #     aux = AuxMaPl(aux,D,Df)
        # return FORALL1(self.var,aux)

    def FPT(self) :
        return FORALL1(self.var,self.fils[0].FPT())

    def AjoutUniq(self,PNF,Lqv) :
        if PNF :
            for v in self.var :
                Lqv.append(UNIQ(v,True))
            return FORALL(self.var, self.fils[0].AjoutUniq(PNF,Lqv))
        else : # pas PNF on traite localement
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            Lres=[]
            for v in self.var :
                Lres.append(UNIQ(v,True))
            if len(Lres) > 0 :
                return FORALL(self.var,IMPL(AND(Lres),f1))
            elif len(Lres)==1 :
                return FORALL(self.var,IMPL(Lres[0],f1))
            else : # bizarre...
                return f1 


    def AjoutListConj(self,Lc) :
        aux = self.fils[0]
        return FORALL1(self.var, aux.AjoutListConj(Lc))
 
    def AjoutPropQuant(self,L,p=None) :
        return FORALL1(self.var,self.fils[0].AjoutPropQuant(L,p))

    def toQBF(self,rp,krip,s) :
        print('error ! Forall1 case should not appear in toQBF !')
        return TOP()

    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        if (not stp == krip.start) :
            print("Warning ! FFlat2z3 - FORALL : pb d'arguments !")
        if len(self.var)==0 :
            self.fils[0].FFlat2z3(VarQ,krip,stp,fout,D)
        (PropB, PropBV, PropQ1, PropQ1FA) = VarQ
        fout.write("(forall (")
        for v in self.var :
            if v in PropQ1 : 
                fout.write("("+v+" (_ BitVec "+str(krip.TBVQ)+"))")
            else :
                print("Cas bizarre dans FFlat2z3 - FORALL1 !")
        fout.write(")")
        self.fils[0].FFlat2z3(VarQ,krip,stp,fout,D)
        fout.write(")")
        
    def FNN(self,np,opeq=False) :
        f=self.fils[0].FNN(np,opeq)
        if np :
            return EXISTS1(self.var,f)
        else :
            return FORALL1(self.var,f)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(2)
        if lq==1 or lq==3 :
            nba+=1
        lv = len(self.var)
        return (t+lv,ht,nba,nbqv+lv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (FORALL1 in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return FORALL1(self.var[:],self.fils[0].TraitementEUAUAF(prop))
  
###############################################################################
#                          EXISTS
###############################################################################
class EXISTS :
    def __init__(self, varList, a) :
        self.fils=[a]
        self.var=varList

    def toString(self) :
        #print("Exist toString :")
        #print (self.fils)
        #print(self.varList)
        if len(self.var)==0 :
            print("Warning ! Exists with an an empty list of var !")
            return self.fils[0].toString()
        ans='Ex '+self.var[0]
        for v in self.var[1:] :
            ans=ans+" "+v
        return ans+"."+ (self.fils[0].toString())
#        ans=""
#        for v in self.var :
#            ans=ans+"("+v+" Bool)"
#        return "(exists ("+ans+") "+self.fils[0].toString()+")"

    def SimplifB(self) :
        f1=self.fils[0].SimplifB()
        if isinstance(f1,EXISTS) :
            f1.var.extend(self.var)
            return f1
        elif isinstance(f1,TOP) :
            return TOP()
        elif isinstance(f1,BOTTOM) :
            return BOTTOM()
        else : 
            return EXISTS(self.var,f1)

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        if qblock :
            fout.write("exists( ")
            listevar(self.var,fout)
            fout.write(")\n")
            if isinstance(self.fils[0],FORALL) or isinstance(self.fils[0],FORALL1) or isinstance(self.fils[0],EXISTS) or isinstance(self.fils[0],EXISTS1) :
                self.fils[0].toQCIR(gatestab,fout,qblock)
            else :
                ngate = newGate()
                fout.write("output("+ngate+")\n")
                fout.write("gtrue = and()\n")
                fout.write("gfalse = or()\n")
                aux = self.fils[0].toQCIR(gatestab,fout,False,ngate) # correction 4/12
                return ""
        else : # un quantificateur hors bloc initial (non Prenex)
            if ng==None :
                ngate=newGate()
            else :
                ngate=ng
            gaux=self.fils[0].toQCIR(gatestab,fout,qblock,None)
            fout.write(ngate+" = exists(")
            listevar(self.var,fout)
            fout.write(";"+gaux+")\n")
            return ngate

    def toZ3(self,fout) :
        fout.write("(exists (")
        for v in self.var :
            fout.write("(")
            fout.write(v)
            fout.write(" Bool)")
        fout.write(") ")
        self.fils[0].toZ3(fout)
        fout.write(")")
        
    def PropQuant(self) :
        (lres,lres1,lres2) = self.fils[0].PropQuant()
        L=self.var[:]
        lres.extend(L)
        return (lres,lres1,lres2)
        
    def write(self, output) :
        output.write("(exists (")
        for v in self.var :
            output.write("(")
            output.write(v)
            output.write(" Bool)")
        output.write(") ")
        self.fils[0].write(output)
        output.write(")")

    def nbalt(self,t = None) :
        if t==None :
            return self.fils[0].nbalt(0)
        elif t==1 :
            return 1+self.fils[0].nbalt(0)
        else :
            return self.fils[0].nbalt(0)

    def isPNF(self,niveau) :
        if not niveau :
            return False
        return self.fils[0].isPNF(niveau)

    def MaPl(self,D,Df,niv,justeX =0) :
        if (len(D) > 0) :
            print("Warning ! Mise-a-plat d'une formule qui n'est pas sous forme Prenex (EXISTS) !")
        # if niv != -1 :
        #     print("Warning ! Mauvaise valeur pour init dans la mise a plat d'une formule (EXISTS) !")
        return EXISTS(self.var,self.fils[0].MaPl(D,Df,niv,justeX))
    
        # if (len(D) > 0) : 
        #     print("Warning ! Mise-a-plat d'une formule qui n'est pas sous forme Prenex (EXISTS) !")
        # sf=self.fils[0]
        # if isinstance(sf,FORALL) or isinstance(sf,FORALL1) or isinstance(sf,EXISTS) or isinstance(sf,EXISTS) :
        #     aux = self.fils[0].MaPl(D,Df)
        # else :
        #     aux = sf.MaPl(D,Df)
        #     aux = AuxMaPl(aux,D,Df)
        # return EXISTS(self.var,aux)

    def AjoutUniq(self,PNF,Lqv) :
        return EXISTS(self.var,self.fils[0].AjoutUniq(PNF,Lqv))

    def FPT(self) :
        return EXISTS(self.var,self.fils[0].FPT())

    
    def AjoutListConj(self,Lc) :
        aux = self.fils[0]
        return EXISTS(self.var, aux.AjoutListConj(Lc))
 
    def AjoutPropQuant(self,L,p=None) :
        return EXISTS(self.var,self.fils[0].AjoutPropQuant(L,p))

    def toQBF(self,rp,krip,s) :
        if len(self.var)==0 :
            self.fils[0].toQBF(VarQ,krip,s,method,EA1)
        VarQ, VarQone, QBVvarpf, ku, kea, met, ea1 = rp.BQProp, rp.QPropEA, rp.BVQProppf, rp.Kpf, rp.Kea, rp.method, rp.codageEA1
        Lv = []
        for v in self.var :
            if (ea1 == 3 or ea1==6) and v in VarQone :   # BitVec !
                laux = BVgeneBV(v,kea)
                Lv.extend(laux)
            else :
                for st in krip.accessibles[s] :
                    if v in QBVvarpf  :  # BitVec too
                        aux=v+"_"+Kripkestring_of_state(st)
                        laux = BVgeneBV(aux,ku)
                        Lv.extend(laux)
                    else :
                        Lv.append(v+"_"+Kripkestring_of_state(st))
        return EXISTS(Lv,self.fils[0].toQBF(rp,krip,s))

    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        if (not stp == krip.start) :
            print("Warning ! FFlat2z3 - FORALL : pb d'arguments !")
        if len(self.var)==0 :
            self.fils[0].FFlat2z3(VarQ,krip,stp,fout,D)
        (PropB, PropBV, PropQ1, PropQ1FA) = VarQ
        fout.write("(exists (")
        for v in self.var :
            if v in PropB :
                for s in krip.accessibles[stp] : 
                    fout.write("("+v+"_"+Kripkestring_of_state(s)+" Bool)")
            elif v in PropBV :
                for s in krip.accessibles[stp] : 
                    fout.write("("+v+"_"+Kripkestring_of_state(s)+" (_ BitVec "+str(krip.TBVU)+"))")
            else :
                print("Cas bizarre dans FFlat2z3 - EXISTS !")
        fout.write(")")
        if isinstance(self.fils[0],EXISTS) or isinstance(self.fils[0],EXISTS1) or isinstance(self.fils[0],FORALL) or isinstance(self.fils[0],FORALL1) : 
            self.fils[0].FFlat2z3(VarQ,krip,stp,fout,D)
        else :   # C'est le dernier EXISTS !! [celui des modalites CTL]
            fout.write("\n (or ")
            for v in PropQ1FA : # on ecarte les cas ou leur valeurs sont audela du nb d'etats !
                fout.write(" (bvuge "+v+" "+krip.cNumero()+") ")
            fout.write("\n (and ")
            self.fils[0].FFlat2z3(VarQ,krip,stp,fout,D)
            (Dp,Df) = D
            for fname in Df :
                Faux = Df[fname]
                pFaux = Dp[fname]
                Faux.AGFlat2z3(pFaux,VarQ,krip,stp,fout,D)
                fout.write("\n")
            #il faut integrer les AG(p<=> def) !
            # on ajoute les bornes sup pour les BV
            for v in PropBV :
                for s in krip.accessibles[stp]  :
                    fout.write(" (bvule "+v+"_"+Kripkestring_of_state(s)+" "+krip.cBUntil()+") ")
            for v in PropQ1 :
                    if v not in PropQ1FA : # on ne restreint que les Exists_1
                        fout.write(" (bvule "+v+" "+krip.cNumero()+") ")                
            fout.write("))")
        fout.write(")")
        
    def FNN(self,np,opeq=False) :
        f=self.fils[0].FNN(np,opeq)
        if np :
            return FORALL(self.var,f)
        else :
            return EXISTS(self.var,f)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(1)
        if lq==2 or lq==3 :
            nba+=1
        lv = len(self.var)
        return (t+lv,ht,nba,nbqv+lv)
    
    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (EXISTS in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return EXISTS(self.var[:],self.fils[0].TraitementEUAUAF(prop))

###############################################################################
#                          EXISTS1
###############################################################################
# exists1 = chaque prop de varlist est vraie dans exactelment un etat du modele... 
class EXISTS1 :
    def __init__(self, varList, a) :
        self.fils=[a]
        self.var=varList

    def toString(self) :
        #print("Exist1 toString :")
        #print (self.fils)
        #print(self.varList)
        if len(self.var)==0 :
            print("Warning ! Exists1 with an an empty list of var !")
            return self.fils[0].toString()
        ans='Ex1 '+self.var[0]
        for v in self.var[1:] :
            ans=ans+" "+v
        return ans+"."+self.fils[0].toString()
#        ans=""
#        for v in self.var :
#            ans=ans+"("+v+" Bool)"
#        return "(exists1 ("+ans+") "+self.fils[0].toString()+")"

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR not defined for EXISTS1 ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for EXISTS1 ! ")
        
    def SimplifB(self) :
        f1=self.fils[0].SimplifB()
        if isinstance(f1,EXISTS1) :
            f1.var.extend(self.var)
            return f1
        elif isinstance(f1,TOP) :
            return TOP()
        elif isinstance(f1,BOTTOM) :
            return BOTTOM()
        else : 
            return EXISTS1(self.var,f1)

    def PropQuant(self) : 
        (lres,lres1,lres2) = self.fils[0].PropQuant()
        L=self.var[:]
        lres1.extend(L)
        return (lres,lres1,lres2)
    
    def write(self, output) :
        print('ne devrait pas passer par ici ! EXISTS1:write !')
        output.write("(exists (")
        for v in self.var :
            output.write("(")
            output.write(v)
            output.write(" Bool)")
        output.write(") ")
        self.fils[0].write(output)
        output.write(")")

    def nbalt(self,t = None) :
        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
        return 0

    def isPNF(self,niveau) :
        if not niveau :
            return False
        return self.fils[0].isPNF(niveau)
    
    def MaPl(self,D,Df,niv,justeX =0) :
        if (len(D) > 0) :
            print("Warning ! Mise-a-plat d'une formule qui n'est pas sous forme Prenex (EXISTS1) !")
        # if niv != -1 :
        #     print("Warning ! Mauvaise valeur pour init dans la mise a plat d'une formule (EXISTS1) !")
        return EXISTS1(self.var,self.fils[0].MaPl(D,Df,niv,justeX))
    
        # if (len(D) > 0) : 
        #     print("Warning ! Mise-a-plat d'une formule qui n'est pas sous forme Prenex (EXISTS1) !")
        # sf=self.fils[0]
        # if isinstance(sf,FORALL) or isinstance(sf,FORALL1) or isinstance(sf,EXISTS) or isinstance(sf,EXISTS) :
        #     aux = self.fils[0].MaPl(D,Df)
        # else :
        #     aux = sf.MaPl(D,Df)
        #     aux = AuxMaPl(aux,D,Df)
        # return EXISTS1(self.var,aux)

    def FPT(self) :
        return EXISTS1(self.var,self.fils[0].FPT())

    def AjoutUniq(self,PNF,Lqv) :   
        if PNF :
            for v in self.var :
                Lqv.append(UNIQ(v,False))
            return EXISTS(self.var, self.fils[0].AjoutUniq(PNF,Lqv))
        else : # pas PNF on traite localement
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            Lres=[]
            for v in self.var :
                Lres.append(UNIQ(v,False))
            Lres.append(f1)
            return EXISTS(self.var,AND(Lres))
    
    def AjoutListConj(self,Lc) :
        aux = self.fils[0]
        return EXISTS1(self.var, aux.AjoutListConj(Lc))
 
    def AjoutPropQuant(self,L,p=None) :
        return EXISTS1(self.var,self.fils[0].AjoutPropQuant(L,p))

    def toQBF(self,rp,krip,s) :
        print('error ! Exists1 case should not appear in toQBF !')
        return TOP()


    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        if (not stp == krip.start) :
            print("Warning ! FFlat2z3 - FORALL : pb d'arguments !")
        if len(self.var)==0 :
            self.fils[0].FFlat2z3(VarQ,krip,stp,fout,D)
        (PropB, PropBV, PropQ1, PropQ1FA) = VarQ
        fout.write("(exists (")
        for v in self.var :
            if v in PropQ1 : 
                fout.write("("+v+" (_ BitVec "+str(krip.TBVQ)+"))")
            else :
                print("Cas bizarre dans FFlat2z3 - EXISTS1 !")
        fout.write(")")
        self.fils[0].FFlat2z3(VarQ,krip,stp,fout,D)
        fout.write(")")
        
    def FNN(self,np,opeq=False) :
        f=self.fils[0].FNN(np,opeq)
        if np :
            return FORALL1(self.var,f)
        else :
            return EXISTS1(self.var,f)


    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(1)
        if lq==2 or lq==3 :
            nba+=1
        lv = len(self.var)
        return (t+lv,ht,nba,nbqv+lv)


    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (EXISTS1 in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return EXISTS1(self.var[:],self.fils[0].TraitementEUAUAF(prop))

###############################################################################
#                          EX
###############################################################################
class EX :
    def __init__(self, a) :
        self.fils=[a]

    def toString(self) :
#        return "(EX "+self.fils[0].toString()+")"
        return "EX ("+self.fils[0].toString()+")"
    
    def SimplifB(self) :
        fs=self.fils[0].SimplifB()
        if isinstance(fs,BOTTOM) :
            return BOTTOM()
        else :
            return EX(fs)

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for EX ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for EX ! ")
    
    def PropQuant(self) : 
        return self.fils[0].PropQuant()
 
    def nbalt(self,t = None) :
#        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
        return self.fils[0].nbalt(t)

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(False)

    def MaPl(self,D,Df,niv,justeX =0) :
        # si niv <1, on descend...
        # sinon on cherche si self est deja dans D, et si oui on renvoie la prop associee
        # sinon on renvoie une nouvelle prop que l'on insere dans D
        f1 = self.fils[0].MaPl(D,Df,1,0)
        if niv==-1 :
            return AuxMaPl(EX(f1),D,Df)
        elif niv==0 : 
            return EX(f1)
        else : 
            aux=EX(f1)
            index=aux.toString()
            if index in D :
                prop = D[index]
            else :
                prop = getIdent()
                D[index]=prop
                Df[index]=aux
        return AP(prop)

    def FPT(self) :
        return EX(self.fils[0].FPT())

    def AjoutUniq(self,PNF,Lqv) : 
        if PNF and len(Lqv)==0 :
            return EX(self.fils[0])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            return EX(f1)
    
    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)
 
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def toQBF(self,rp,krip,s) :
        if len(krip.succ[s])==1 :
                for stp in krip.succ[s] :
                       return self.fils[0].toQBF(rp,krip,stp)
        else :
            L=[]
            for stp in krip.succ[s] :# on doit avoir:  \/_{st->st'} p_f1_st' 
                L.append(self.fils[0].toQBF(rp,krip,stp)) 
            return OR(L)
    
    def QcirReduc(self,p,VarQ,version,pq=None) :
        return AG(IMPL(AP(p),EX(self.fils[0])))
    
    def AGFlat2z3(self,pFaux,VarQ,krip,s,fout,D) :  # ecrit sur fout une liste (conj) de formules propo pour coder les def de AG(p<=> def)
        f1=self.fils[0]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        fp=AP(pFaux)
        for st in krip.accessibles[s] :
            fout.write("(= ")
            fp.FFlat2z3(VarQ,krip,st,fout,D)
            if len(krip.succ[st])==1 :
                fout.write(" ")
                for stp in krip.succ[st] : 
                    f1.FFlat2z3(VarQ,krip,stp,fout,D)
            else :
                fout.write("(or ")
                for stp in krip.succ[st] :# pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
                    f1.FFlat2z3(VarQ,krip,stp,fout,D) # renvoie la formule Booleenne f1 "sur" st' !
                    fout.write(" ")
                fout.write(")")
            fout.write(")\n")
        

    def FFlat2z3(self,VarQ,krip,st,fout,D)  :
        f1=self.fils[0]
        if len(krip.succ[st])==1 :
                for stp in krip.succ[st] : 
                        f1.FFlat2z3(VarQ,krip,stp,fout,D)
        else :
            fout.write("(or ")
            for stp in krip.succ[st] :# on doit avoir:  \/_{st->st'} p_f1_st' 
                f1.FFlat2z3(VarQ,krip,stp,fout,D) # pas optimal ! 
            fout.write(")")
        
    def FNN(self,np,opeq=False) :
        f=self.fils[0].FNN(np,opeq)
        if np :
            return AX(f)
        else :
            return EX(f)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(lq)
        ht+=1
        return (t+1,ht,nba,nbqv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        if dejavuX :
            return False
        return self.fils[0].isCBEAXap(True)
    
    def ContainsOP(self,L) :
        if (EX in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return self

###############################################################################
#                          AX
###############################################################################
class AX :
    def __init__(self, a) :
        self.fils=[a]

    def toString(self) :
        return "AX( "+self.fils[0].toString()+")"
#        return "(AX "+self.fils[0].toString()+")"

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for AX ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for AX ! ")
        
    def SimplifB(self) :
        fs=self.fils[0].SimplifB()
        if isinstance(fs,TOP) :
            return TOP()
        else :
            return AX(fs)

    def PropQuant(self) : 
        return self.fils[0].PropQuant()
 
    def nbalt(self,t = None) :
#        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
#        return 0
        return self.fils[0].nbalt(t)


    def isPNF(self,niveau) :
        return self.fils[0].isPNF(False)

    def MaPl(self,D,Df,niv,justeX =0) :
        f1 = self.fils[0].MaPl(D,Df,1,0)
        if niv == -1 :
                return AuxMaPl(AX(f1),D,Df)
        elif niv==0 : 
            return AX(f1)
        else : 
            aux=AX(f1) 
            index=aux.toString()
            if index in D :
                prop = D[index]
            else :
                prop = getIdent()
                D[index]=prop
                Df[index]=aux
        return AP(prop)

    def AjoutUniq(self,PNF,Lqv) : 
        if PNF and len(Lqv)==0 :
            return AX(self.fils[0])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            return AX(f1)
        
    def FPT(self) :
        return AX(self.fils[0].FPT())

    
    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)
 
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def QcirReduc(self,p,VarQ,version,pq=None) :
        return AG(IMPL(AP(p),AX(self.fils[0])))
  
    def AGFlat2z3(self,pFaux,VarQ,krip,s,fout,D) :  # ecrit sur fout une liste (conj) de formules propo pour coder les def de AG(p<=> def)
        f1=self.fils[0]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        fp=AP(pFaux)
        for st in krip.accessibles[s] :
            fout.write("(= ")
            fp.FFlat2z3(VarQ,krip,st,fout,D)
            if len(krip.succ[st])==1 :
                fout.write(" ")
                for stp in krip.succ[st] :
                    f1.FFlat2z3(VarQ,krip,stp,fout,D)  
            else :
                fout.write("(and ")
                for stp in krip.succ[st] :# pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
                    f1.FFlat2z3(VarQ,krip,stp,fout,D) # renvoie la formule Booleenne f1 "sur" st' !
                    fout.write(" ")
                fout.write(")")
            fout.write(")\n")


    def toQBF(self,rp,krip,s) :
        if len(krip.succ[s])==1 :
                for stp in krip.succ[s] :
                       return self.fils[0].toQBF(rp,krip,stp)
        else :
            L=[]
            for stp in krip.succ[s] :# on doit avoir:  \/_{st->st'} p_f1_st' 
                L.append(self.fils[0].toQBF(rp,krip,stp)) 
            return AND(L)
    
    def FFlat2z3(self,VarQ,krip,st,fout,D)  :
        f1=self.fils[0]
        if len(krip.succ[st])==1 :
                for stp in krip.succ[st] : 
                        f1.FFlat2z3(VarQ,krip,stp,fout,D)
        else :
            fout.write("(and ")
            for stp in krip.succ[st] :# on doit avoir:  /\_{st->st'} p_f1_st' 
                f1.FFlat2z3(VarQ,krip,stp,fout,D) # pas optimal ! 
            fout.write(")")
        
    def FNN(self,np,opeq=False) :
        f=self.fils[0].FNN(np,opeq)
        if np :
            return EX(f)
        else :
            return AX(f)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(lq)
        ht+=1
        return (t+1,ht,nba,nbqv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        if dejavuX :
            return False
        return self.fils[0].isCBEAXap(True)

    def ContainsOP(self,L) :
        if (AX in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return self

###############################################################################
#                          EU
###############################################################################
class EU :
    def __init__(self, a1, a2) :
        self.fils=[a1, a2]

    def toString(self) :
        return "E "+self.fils[0].toString()+" U "+self.fils[1].toString()
#        return "(E "+self.fils[0].toString()+" U "+self.fils[1].toString()+")"

    def SimplifB(self) :
        f1=self.fils[0].SimplifB()
        f2=self.fils[1].SimplifB()
        if isinstance(f2,TOP) :
            return TOP()
        elif isinstance(f1,BOTTOM) :
            return f2
        else :
            return EU(f1,f2)  # on pourrait renvoyer EF si f1=T...

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for EU ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for EU ! ")
        
    def PropQuant(self) : 
        (L,L1,L2)=self.fils[0].PropQuant()
        (M,M1,M2)=self.fils[1].PropQuant()
        L.extend(M)
        L1.extend(M1)
        L2.extend(M2)
        return (L,L1,L2)
    
    def nbalt(self,t = None) :
#        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
#        return 0
        return max(self.fils[0].nbalt(t),self.fils[1].nbalt(t))

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(False) and self.fils[1].isPNF(False)

    def MaPl(self,D,Df,niv,justeX =0) :
        aux1 = self.fils[0].MaPl(D,Df,1,0)
        aux2 = self.fils[1].MaPl(D,Df,1,0)
        if niv == -1 :
            return AuxMaPl(EU(aux1,aux2),D,Df)
        elif niv == 0 and (justeX==0 or justeX==3): 
            return EU(aux1,aux2)
        else : 
            aux=EU(aux1,aux2)
            index=aux.toString()
            if index in D :
                prop = D[index]
            else :
                prop = getIdent()
                D[index]=prop
                Df[index]=aux
#            if niv == -1 :
#                return AuxMaPl(AP(prop),D,Df)
            return AP(prop)

    def AjoutUniq(self,PNF,Lqv) : 
        if PNF and len(Lqv)==0 :
            return EU(self.fils[0],self.fils[1])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            f2 = self.fils[1].AjoutUniq(PNF,Lqv)
            return EU(f1,f2)
        
    def FPT(self) :
        f1=self.fils[0].FPT()
        f2=self.fils[1].FPT()
        qv=getIdent()
        return FORALL([qv],IMPL(AG(EQ(AP(qv),OR(f2,AND(f1,EX(AP(qv)))))),AP(qv)))
    #  OU ??      return FORALL([qv],IMPL(AG(IMPL(OR(f2,AND(f1,EX(AP(qv)))),AP(qv))),AP(qv)))

    
    def AjoutListConj(self,Lc) :
        Lc.extend(self)
        return AND(Lc)

    def toQBF(self,rp,krip,s) :
        VarQ, VarQone, QBVvarpf, ku, kea, met, ea1 = rp.BQProp, rp.QPropEA, rp.BVQProppf, rp.Kpf, rp.Kea, rp.method, rp.codageEA1
        if met=='UU' or met=='FUU' :
            # to be done
            return auxUU_EU(self,rp,krip,s,[])
#            print("toQBF / EU / method UU : to be done !!")
        else :
            print('Error : no EU should occur in a formula in toQBF()')
            # NB: pour FBV les EU sont traites en amont en traitant AG (p => E a U b)
        return TOP()

    
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def QcirReduc(self,p,VarQ,version,pq=None) :
        if version==1 :
            newp = '_q'+p[2:]
            VarQ.append(newp)
            return FORALL([newp],OR([EF(AND([OR([self.fils[1],AND([self.fils[0],EX(AP(newp))])]),NOT(AP(newp))])),AG(IMPL(AP(p),AP(newp)))]))
        else : # version 2
             return OR([EF(AND([OR([self.fils[1],AND([self.fils[0],EX(AP(pq))])]),NOT(AP(pq))])),AG(IMPL(AP(p),AP(pq)))])

  
    
    def AGFlat2z3(self,pFaux,VarQ,krip,s,fout,D) :  # ecrit sur fout une liste (conj) de formules propo pour coder les def de AG(p<=> def)
        f1=self.fils[0]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        f2=self.fils[1]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        fp=AP(pFaux)
        for st in krip.accessibles[s] :
            fout.write("(=> ")      # => vs <=>
            fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(st)+" "+krip.cDistance(0)+") ")
            f2.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(") ")
            for d in range(1,krip.BUntil) :
                fout.write("(=> ")   # => vs <=>
                fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(st)+" "+krip.cDistance(d)+") ")
                fout.write(" (and ")
                f1.FFlat2z3(VarQ,krip,st,fout,D)
                fout.write(" ")
                if len(krip.succ[st])==1 :
                    for stp in krip.succ[st] : 
                        fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(stp)+" "+krip.cDistance(d-1)+") ")
                else :
                    fout.write("(or ")
                    for stp in krip.succ[st] :
                        fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(stp)+" "+krip.cDistance(d-1)+") ")
                        fout.write(" ")
                    fout.write(")")
                fout.write("))")
        fout.write("\n")
        
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        print("Warning ! FFlat2z3 ne devrait pas etre appele sur "+str(type(self)))
        
        
    def FNN(self,np,opeq=False) :
        f1=self.fils[0].FNN(np,opeq)
        f2=self.fils[1].FNN(np,opeq)
        if np :
            return AW(f2,AND(f1,f2))
        else :
            return EU(f1,f2)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t0,ht0,nba0,nbqv0) = self.fils[0].Size(lq)
        (t1,ht1,nba1,nbqv1) = self.fils[1].Size(lq)
        return (t0+t1+1,max(ht0,ht1)+1,max(nba0,nba1),nbqv0+nbqv1)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False
 
    def ContainsOP(self,L) :
        if (EU in L) :
            return True
        return self.fils[0].ContainsOP(L) or self.fils[1].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        # to be done !!!! 
        return IMPL(AG(IMPL(OR([self.fils[1],AND([self.fils[0],EX(AP(prop))])]),AP(prop))),AP(prop))
   
###############################################################################
#                          AU
###############################################################################
class AU :
    def __init__(self, a1, a2) :
        self.fils=[a1, a2]

    def toString(self) :
        return "A "+self.fils[0].toString()+" U "+self.fils[1].toString()
#        return "(A "+self.fils[0].toString()+" U "+self.fils[1].toString()+")"

    def SimplifB(self) :
        f1=self.fils[0].SimplifB()
        f2=self.fils[1].SimplifB()
        if isinstance(f2,TOP) :
            return TOP()
        elif isinstance(f1,BOTTOM) :
            return f2
        else :
            return AU(f1,f2)  # on pourrait renvoyer AF si f1=T...

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for AU ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for AU ! ")
        
    def PropQuant(self) : 
        (L,L1,L2)=self.fils[0].PropQuant()
        (M,M1,M2)=self.fils[1].PropQuant()
        L.extend(M)
        L1.extend(M1)
        L2.extend(M2)
        return (L,L1,L2)
    
    def nbalt(self,t = None) :
#        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
#        return 0
        return max(self.fils[0].nbalt(t),self.fils[1].nbalt(t))

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(False) and self.fils[1].isPNF(False)

    def MaPl(self,D,Df,niv,justeX =0) :
        aux1 = self.fils[0].MaPl(D,Df,1,0)
        aux2 = self.fils[1].MaPl(D,Df,1,0)
        if niv == -1 :
            return AuxMaPl(AU(aux1,aux2),D,Df)
        elif niv == 0 and (justeX==0 or justeX==3): 
            return AU(aux1,aux2)
        else : 
            aux=AU(aux1,aux2)
            index=aux.toString()
            if index in D :
                prop = D[index]
            else :
                prop = getIdent()
                D[index]=prop
                Df[index]=aux
#            if niv == -1 :
#                return AuxMaPl(AP(prop),D,Df)
        return AP(prop)

    def AjoutUniq(self,PNF,Lqv) : 
        if PNF and len(Lqv)==0 :
            return AU(self.fils[0],self.fils[1])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            f2 = self.fils[1].AjoutUniq(PNF,Lqv)
            return AU(f1,f2)
        
    def FPT(self) :
        f1=self.fils[0].FPT()
        f2=self.fils[1].FPT()
        qv=getIdent()
        return FORALL([qv],IMPL(AG(EQ(AP(qv),OR(f2,AND(f1,AX(AP(qv)))))),AP(qv)))
    #  OU ??      return FORALL([qv],IMPL(AG(IMPL(OR(f2,AND(f1,AX(AP(qv)))),AP(qv))),AP(qv)))

    def AjoutListConj(self,Lc) :
        Lc.extend(self)
        return AND(Lc)
 
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))
        
    def toQBF(self,rp,krip,s) :
        if rp.method=='UU' or rp.method=='FUU' :
            # to be done
            return auxUU_AU(self,rp,krip,s,[])
#            print("toQBF / AU / method UU : to be done !!")
        else :
            print('Error : no AU should occur in a formula in toQBF()')
            # NB: pour FBV les EU sont traites en amont en traitant AG (p => E a U b)
        return TOP()
    
    def QcirReduc(self,p,VarQ,version,pq=None) :
        if version==1 : 
            newp = '_q'+p[2:]
            VarQ.append(newp)
            return FORALL([newp],OR([EF(AND([OR([self.fils[1],AND([self.fils[0],AX(AP(newp))])]),NOT(AP(newp))])),AG(IMPL(AP(p),AP(newp)))]))
        else :
            return OR([EF(AND([OR([self.fils[1],AND([self.fils[0],AX(AP(pq))])]),NOT(AP(pq))])),AG(IMPL(AP(p),AP(pq)))])
 
    def AGFlat2z3(self,pFaux,VarQ,krip,s,fout,D) :  # ecrit sur fout une liste (conj) de formules propo pour coder les def de AG(p<=> def)
        f1=self.fils[0]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        f2=self.fils[1]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        fp=AP(pFaux)
        for st in krip.accessibles[s] :
            fout.write("(=> ")   # => vs <=>
            fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(st)+" "+krip.cDistance(0)+") ")
            f2.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(") ")
            for d in range(1,krip.BUntilD()) :
                fout.write("(=> ")    # => vs <=>
                fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(st)+" "+krip.cDistance(d)+") ")
                fout.write(" (and ")
                f1.FFlat2z3(VarQ,krip,st,fout,D)
                fout.write(" ")
                for stp in krip.succ[st] :
                    fout.write(" (bvult "+pFaux+"_"+Kripkestring_of_state(stp)+" "+krip.cDistance(d)+") ")
                    fout.write(" ")
                fout.write(")")
            fout.write(")")
        fout.write("\n")
        
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        print("Warning ! FFlat2z3 ne devrait pas etre appele sur "+str(type(self)))
        
    def FNN(self,np,opeq=False) :
        f1=self.fils[0].FNN(np,opeq)
        f2=self.fils[1].FNN(np,opeq)
        if np :
            return EW(f2,AND(f1,f2))
        else :
            return AU(f1,f2)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t0,ht0,nba0,nbqv0) = self.fils[0].Size(lq)
        (t1,ht1,nba1,nbqv1) = self.fils[1].Size(lq)
        return (t0+t1+1,max(ht0,ht1)+1,max(nba0,nba1),nbqv0+nbqv1)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (AU in L) :
            return True
        return self.fils[0].ContainsOP(L) or self.fils[1].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        # to be done !!!! 
        return IMPL(AG(IMPL(OR([self.fils[1],AND([self.fils[0],AX(AP(prop))])]),AP(prop))),AP(prop))

   
###############################################################################
#                          EW
###############################################################################
class EW :
    def __init__(self, a1, a2) :
        self.fils=[a1, a2]

    def toString(self) :
        return "E "+self.fils[0].toString()+" W "+self.fils[1].toString()
#        return "(E "+self.fils[0].toString()+" W "+self.fils[1].toString()+")"

    def SimplifB(self) :
        f1=self.fils[0].SimplifB()
        f2=self.fils[1].SimplifB()
        if isinstance(f1,TOP) or  isinstance(f2,TOP) :
            return TOP()
        elif isinstance(f1,BOTTOM) :
            return f2
        else :
            return EW(f1,f2)  # on pourrait renvoyer EG si f2=bot...

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for EW ! ")
        return ""
    
    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for EW ! ")
    
    def PropQuant(self) : 
        (L,L1,L2)=self.fils[0].PropQuant()
        (M,M1,M2)=self.fils[1].PropQuant()
        L.extend(M)
        L1.extend(M1)
        L2.extend(M2)
        return (L,L1,L2)
    
    def nbalt(self,t = None) :
#        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
#        return 0
        return max(self.fils[0].nbalt(t),self.fils[1].nbalt(t))

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(False) and self.fils[1].isPNF(False)

    def MaPl(self,D,Df,niv,justeX =0) :
        aux1 = self.fils[0].MaPl(D,Df,1,0)
        aux2 = self.fils[1].MaPl(D,Df,1,0)
        if niv == -1  : 
            return AuxMaPl(EW(aux1,aux2),D,Df)
        elif niv == 0 and justeX==0: 
            return EW(aux1,aux2)
        else : 
            aux=EW(aux1,aux2)
            index=aux.toString()
            if index in D :
                prop = D[index]
            else :
                prop = getIdent()
                D[index]=prop
                Df[index]=aux
        return AP(prop)

    def AjoutUniq(self,PNF,Lqv) : 
        if PNF and len(Lqv)==0 :
            return EW(self.fils[0],self.fils[1])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            f2 = self.fils[1].AjoutUniq(PNF,Lqv)
            return EW(f1,f2)
        
    def FPT(self) :
        f1=self.fils[0].FPT()
        f2=self.fils[1].FPT()
        qv=getIdent()
        return EXISTS([qv],AND(AP(qv),AG(IMPL(AP(qv),OR(f2,AND(f1,EX(AP(qv))))))))
    #  OU ??    avec un EQ ?
    
    def AjoutListConj(self,Lc) :
        Lc.extend(self)
        return AND(Lc)
 
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))
        
    def toQBF(self,rp,krip,s) :
        if rp.method=='UU' or rp.method=='FUU' :
            # to be done
            return auxUU_EW(self,rp,krip,s,[])
#            print("toQBF / EW / method UU : to be done !!")
        else :
            print('Error : no EW should occur in a formula in toQBF()')
            # NB: pour FBV les EU sont traites en amont en traitant AG (p => E a U b)
        return TOP()
    
    def QcirReduc(self,p,VarQ,version,pq=None) :
        return AG(IMPL(AP(p),(OR([self.fils[1],AND([self.fils[0],EX(AP(p))])]))))
    
    def AGFlat2z3(self,pFaux,VarQ,krip,s,fout,D) :  # ecrit sur fout une liste (conj) de formules propo pour coder les def de AG(p<=> def)
        f1=self.fils[0]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        f2=self.fils[1]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        fp=AP(pFaux)
        for st in krip.accessibles[s] :
            fout.write("(=> ")   # => vs <=>
            fp.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write("(or ")
            f2.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(" (and ")
            f1.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(" ")
            if len(krip.succ[st])==1 :
                for stp in krip.succ[st] :
                    fp.FFlat2z3(VarQ,krip,stp,fout,D)
            else :
                fout.write("(or ")
                for stp in krip.succ[st] :
                    fp.FFlat2z3(VarQ,krip,stp,fout,D)
                    fout.write(" ")
                fout.write(")")
            fout.write(")))")
        fout.write("\n")
    
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        print("Warning ! FFlat2z3 ne devrait pas etre appele sur "+str(type(self)))
        
    def FNN(self,np,opeq=False) :
        f1=self.fils[0].FNN(np,opeq)
        f2=self.fils[1].FNN(np,opeq)
        if np :
            return AU(f2,AND(f1,f2))
        else :
            return EW(f1,f2)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t0,ht0,nba0,nbqv0) = self.fils[0].Size(lq)
        (t1,ht1,nba1,nbqv1) = self.fils[1].Size(lq)
        return (t0+t1+1,max(ht0,ht1)+1,max(nba0,nba1),nbqv0+nbqv1)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (EW in L) :
            return True
        return self.fils[0].ContainsOP(L) or self.fils[1].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return self
    
###############################################################################
#                          AW
###############################################################################
class AW :
    def __init__(self, a1, a2) :
        self.fils=[a1, a2]

    def toString(self) :
        return "A "+self.fils[0].toString()+" W "+self.fils[1].toString()
#        return "(A "+self.fils[0].toString()+" W "+self.fils[1].toString()+")"

    def SimplifB(self) :
        f1=self.fils[0].SimplifB()
        f2=self.fils[1].SimplifB()
        if isinstance(f1,TOP) or  isinstance(f2,TOP) :
            return TOP()
        elif isinstance(f1,BOTTOM) :
            return f2
        else :
            return AW(f1,f2)  # on pourrait renvoyer AG si f2=bot...

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for AW ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for AW ! ")
        
    def PropQuant(self) : 
        (L,L1,L2)=self.fils[0].PropQuant()
        (M,M1,M2)=self.fils[1].PropQuant()
        L.extend(M)
        L1.extend(M1)
        L2.extend(M2)
        return (L,L1,L2)
    
    def nbalt(self,t = None) :
#        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
#        return 0
        return max(self.fils[0].nbalt(t),self.fils[1].nbalt(t))

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(False) and self.fils[1].isPNF(False)
    
    def MaPl(self,D,Df,niv,justeX = 0) :
        aux1 = self.fils[0].MaPl(D,Df,1,0)
        aux2 = self.fils[1].MaPl(D,Df,1,0)
        if niv == -1 :
            return AuxMaPl(AW(aux1,aux2),D,Df)
        elif niv == 0 and justeX==0: 
            return AW(aux1,aux2)
        else : 
            aux=AW(aux1,aux2)
            index=aux.toString()
            if index in D :
                prop = D[index]
            else :
                prop = getIdent()
                D[index]=prop
                Df[index]=aux
        return AP(prop)

    def AjoutUniq(self,PNF,Lqv) : 
        if PNF and len(Lqv)==0 :
            return AW(self.fils[0],self.fils[1])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            f2 = self.fils[1].AjoutUniq(PNF,Lqv)
            return AW(f1,f2)
        
    def FPT(self) :
        f1=self.fils[0].FPT()
        f2=self.fils[1].FPT()
        qv=getIdent()
        return EXISTS([qv],AND(AP(qv),AG(IMPL(AP(qv),OR(f2,AND(f1,AX(AP(qv))))))))
    
    def AjoutListConj(self,Lc) :
        Lc.extend(self)
        return AND(Lc)
 
    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def toQBF(self,rp,krip,s) :
        if rp.method=='UU' or rp.method=='FUU' :
            # to be done
            return auxUU_AW(self,rp,krip,s,[])
#            print("toQBF / AW / method UU : to be done !!")
        else :
            print('Error : no AW should occur in a formula in toQBF()')
            # NB: pour FBV les EU sont traites en amont en traitant AG (p => E a U b)
        return TOP()
    
    def QcirReduc(self,p,VarQ,version,pq=None) :
        return AG(IMPL(AP(p),(OR([self.fils[1],AND([self.fils[0],AX(AP(p))])]))))
 
    def AGFlat2z3(self,pFaux,VarQ,krip,s,fout,D) :  # ecrit sur fout une liste (conj) de formules propo pour coder les def de AG(p<=> def)
        f1=self.fils[0]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        f2=self.fils[1]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        fp=AP(pFaux)
        for st in krip.accessibles[s] :
            fout.write("(=> ")   # => vs <=>
            fp.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write("(or ")
            f2.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(" (and ")
            f1.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(" ")
            if len(krip.succ[st])==1 :
                for stp in krip.succ[st] : 
                    fp.FFlat2z3(VarQ,krip,stp,fout,D)
            else :
                for stp in krip.succ[st] :
                    fp.FFlat2z3(VarQ,krip,stp,fout,D)
                    fout.write(" ")
            fout.write(")))")
        fout.write("\n")
        
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        print("Warning ! FFlat2z3 ne devrait pas etre appele sur "+str(type(self)))
        
    def FNN(self,np,opeq=False) :
        f1=self.fils[0].FNN(np,opeq)
        f2=self.fils[1].FNN(np,opeq)
        if np :
            return EU(f2,AND(f1,f2))
        else :
            return AW(f1,f2)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t0,ht0,nba0,nbqv0) = self.fils[0].Size(lq)
        (t1,ht1,nba1,nbqv1) = self.fils[1].Size(lq)
        return (t0+t1+1,max(ht0,ht1)+1,max(nba0,nba1),nbqv0+nbqv1)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (AW in L) :
            return True
        return self.fils[0].ContainsOP(L) or self.fils[1].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return self
    
###############################################################################
#                          EF
###############################################################################
class EF :
    def __init__(self, a) :
        self.fils=[a]

    def toString(self) :
        return "EF ("+self.fils[0].toString()+")"
#        return "(EF "+self.fils[0].toString()+")"

    def SimplifB(self) :
        f=self.fils[0].SimplifB()
        if isinstance(f,TOP) or isinstance(f,BOTTOM)  :
            return f
        else:
            return EF(f)

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for EF ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for EF ! ")
        
    def PropQuant(self) : 
        return self.fils[0].PropQuant()
    
    def nbalt(self,t = None) :
#        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
        return self.fils[0].nbalt(t)

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(False)

    def MaPl(self,D,Df,niv,justeX =0) :
        f1 = self.fils[0].MaPl(D,Df,1,0)
        if niv==-1 :
            return AuxMaPl(EF(f1),D,Df)
        elif niv==0 and  (justeX==0 or justeX==2 or justeX==3): 
            return EF(f1)
        else : 
            aux=EF(f1)
            index=aux.toString()
            if index in D :
                prop = D[index]
            else :
                prop = getIdent()
                D[index]=prop
                Df[index]=aux
        return AP(prop)

    def AjoutUniq(self,PNF,Lqv) : 
        if PNF and len(Lqv)==0 :
            return EF(self.fils[0])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            return EF(f1)

        # NB: ci-dessous pb de coherence avec la def du papier. Les EF doivent etre remplaces !!
    def FPT(self) :
        f1=self.fils[0].FPT()
        qv=getIdent()
        return FORALL([qv],IMPL(AG(EQ(AP(qv),OR(f1,EX(AP(qv))))),AP(qv)))
    #        return EF(self.fils[0].FPT())
    
    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)

    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))

    def QcirReduc(self,p,VarQ,version,pq=None) :
        if version==1 : 
            newp = '_q'+p[2:]
            VarQ.append(newp)
            return FORALL([newp],OR([EF(AND([OR([self.fils[0],EX(AP(newp))]),NOT(AP(newp))])),AG(IMPL(AP(p),AP(newp)))]))
        else :
            return OR([EF(AND([OR([self.fils[0],EX(AP(pq))]),NOT(AP(pq))])),AG(IMPL(AP(p),AP(pq)))])

    def toQBF(self,rp,krip,s) :
        if len(krip.accessibles[s])==1 :
            for sp in krip.accessibles[s] :
             if s != sp :
                print('error in toQBF/EF : s is not reachable from itself ?!')
                return TOP()
             return self.fils[0].toQBF(rp,krip,s)
        else :
            L = []
            for st in krip.accessibles[s] :
                f = self.fils[0].toQBF(rp,krip,st)
                L.append(f)
        return OR(L)

    
    def AGFlat2z3(self,pFaux,VarQ,krip,s,fout,D) :  # ecrit sur fout une liste (conj) de formules propo pour coder les def de AG(p<=> def)
        f1=self.fils[0]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        for st in krip.accessibles[s] :
            fout.write("(=> ")   # => vs <=>
            fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(st)+" "+krip.cDistance(0)+") ")
            f1.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(") ")
            for d in range(1,krip.BUntilD()) :
                fout.write("(=> ")    # => vs <=>
                fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(st)+" "+krip.cDistance(d)+") ")
                if len(krip.succ[st])==1 :
                    for stp in krip.succ[st] :
                        fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(stp)+" "+krip.cDistance(d-1)+") ")
                else :
                    fout.write("(or ")
                    for stp in krip.succ[st] :
                        fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(stp)+" "+krip.cDistance(d-1)+") ")
                        fout.write(" ")
                    fout.write(")")
                fout.write(")")
        fout.write("\n")
        
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        print("Warning ! FFlat2z3 ne devrait pas etre appele sur "+str(type(self)))
                
    def FNN(self,np,opeq=False) :
        f=self.fils[0].FNN(np,opeq)
        if np :
            return AG(f)
        else :
            return EF(f)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(lq)
        return (t+1,ht+1,nba,nbqv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (EF in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return self
    
###############################################################################
#                          AF
###############################################################################       
class AF :
    def __init__(self, a) :
        self.fils=[a]

    def toString(self) :
        return "AF ("+self.fils[0].toString()+")"
#        return "(AF "+self.fils[0].toString()+")"

    def SimplifB(self) :
        f=self.fils[0].SimplifB()
        if isinstance(f,TOP) or isinstance(f,BOTTOM)  :
            return f
        else:
            return AF(f)

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for AF ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for AF ! ")
        
    def PropQuant(self) : 
        return self.fils[0].PropQuant()
    
    def nbalt(self,t = None) :
#        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
        return self.fils[0].nbalt(t)

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(False)

    def MaPl(self,D,Df,niv,justeX = 0) :
        f1 = self.fils[0].MaPl(D,Df,1,0)
        if niv==-1 :
            return AuxMaPl(AF(f1),D,Df)
        elif niv==0 and  (justeX==0 or justeX==3) : 
            return AF(f1)
        else : 
            aux=AF(f1)
            index=aux.toString()
            if index in D :
                prop = D[index]
            else :
                prop = getIdent()
                D[index]=prop
                Df[index]=aux
        return AP(prop)

    def AjoutUniq(self,PNF,Lqv) : 
        if PNF and len(Lqv)==0 :
            return AF(self.fils[0])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            return AF(f1)
        
    def FPT(self) :
        f1=self.fils[0].FPT()
        qv=getIdent()
        return FORALL([qv],IMPL(AG(EQ(AP(qv),OR(f1,AX(AP(qv))))),AP(qv)))
    # ou avec un IMPL ??

    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)

    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))
        
    def toQBF(self,rp,krip,s) :
#        VarQ, VarQone, QBVvarpf, ku, kea, met, ea1 = rp.BQProp, rp.QPropEA, rp.BVQProppf, rp.Kpf, rp.Kea, rp.method, rp.codageEA1
        if rp.method=='UU' or rp.method=='FUU' :
            # to be done
            return auxUU_AF(self,rp,krip,s,[])
#            print("toQBF / AF / method UU : to be done !!")
        else :
            print('Error : no AF should occur in a formula in toQBF()')
            # NB: pour FBV les EU sont traites en amont en traitant AG (p => E a U b)
        return TOP()

    def QcirReduc(self,p,VarQ,version,pq=None) :
        if version==1 :
            newp = '_q'+p[2:]
            VarQ.append(newp)
            return FORALL([newp],OR([EF(AND([OR([self.fils[0],AX(AP(newp))]),NOT(AP(newp))])),AG(IMPL(AP(p),AP(newp)))]))
        else :
            return OR([EF(AND([OR([self.fils[0],AX(AP(pq))]),NOT(AP(pq))])),AG(IMPL(AP(p),AP(pq)))])

    
    def AGFlat2z3(self,pFaux,VarQ,krip,s,fout,D) :  # ecrit sur fout une liste (conj) de formules propo pour coder les def de AG(p<=> def)
        f1=self.fils[0]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        for st in krip.accessibles[s] :
            fout.write("(=> ")   # => vs <=>
            fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(st)+" "+krip.cDistance(0)+") ")
            f1.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(") ")
            for d in range(1,krip.BUntilD()) :
                fout.write("(=> ")     # => vs <=>
                fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(st)+" "+krip.cDistance(d)+") ")
                if len(krip.succ[st])==1 :
                    for stp in krip.succ[st] :
                        fout.write(" (= "+pFaux+"_"+Kripkestring_of_state(stp)+" "+krip.cDistance(d-1)+") ")
                else :
                    fout.write(" (and ")
                    for stp in krip.succ[st] :
                        fout.write(" (bvult "+pFaux+"_"+Kripkestring_of_state(stp)+" "+krip.cDistance(d)+") ")
                        fout.write(" ")
                    fout.write(")")
                fout.write(")")
        fout.write("\n")
        
    def FFlat2z3(self,VarQ,krip,stp,fout,D) :
        print("Warning ! FFlat2z3 ne devrait pas etre appele sur "+str(type(self)))
        
    def FNN(self,np,opeq=False) :
        f=self.fils[0].FNN(np,opeq)
        if np :
            return EG(f)
        else :
            return AF(f)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(lq)
        return (t+1,ht+1,nba,nbqv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (AF in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return IMPL(AG(IMPL(OR([self.fils[0],AX(AP(prop))]),AP(prop))),AP(prop))

###############################################################################
#                          EG
###############################################################################
class EG :
    def __init__(self, a) :
        self.fils=[a]

    def toString(self) :
        return "EG "+self.fils[0].toString()
#        return "(EG "+self.fils[0].toString()+")"

    def SimplifB(self) :
        f=self.fils[0].SimplifB()
        if isinstance(f,TOP) or isinstance(f,BOTTOM)  :
            return f
        else:
            return EG(f)

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for EG ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for EG ! ")
        
    def PropQuant(self) : 
        return self.fils[0].PropQuant()
        
    def nbalt(self,t = None) :
#        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
        return self.fils[0].nbalt(t)


    def isPNF(self,niveau) :
        return self.fils[0].isPNF(False)
    
    def MaPl(self,D,Df,niv,justeX = 0) :
        f1 = self.fils[0].MaPl(D,Df,1,0)
        if niv==-1 :
            return AuxMaPl(EG(f1),D,Df)
        elif niv==0 and  justeX==0: 
            return EG(f1)
        else : 
            aux=EG(f1)
            index=aux.toString()
            if index in D :
                prop = D[index]
            else :
                prop = getIdent()
                D[index]=prop
                Df[index]=aux
        return AP(prop)

    def AjoutUniq(self,PNF,Lqv) : 
        if PNF and len(Lqv)==0 :
            return EG(self.fils[0])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            return EG(f1)
        
    def FPT(self) :
        f1=self.fils[0].FPT()
        qv=getIdent()
        return EXISTS([qv],AND(AP(qv),AG(IMPL(AP(qv),AND(f1,EX(AP(qv)))))))
    # ou avec un EQ ??
    
    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)

    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))
        
    def QcirReduc(self,p,VarQ,version,pq=None) :
        return AG(IMPL(AP(p),AND([self.fils[0],EX(AP(p))])))
 
    def toQBF(self,rp,krip,s) :
#        VarQ, VarQone, QBVvarpf, ku, kea, met, ea1 = rp.BQProp, rp.QPropEA, rp.BVQProppf, rp.Kpf, rp.Kea, rp.method, rp.codageEA1
        if rp.method=='UU' or rp.method=='FUU' :
            # to be done
            return auxUU_EG(self,rp,krip,s,[])
#            print("toQBF / EG / method UU : to be done !!")
        else :
            print('Error : no EG should occur in a formula in toQBF()')
            # NB: pour FBV les EU sont traites en amont en traitant AG (p => E a U b)
        return TOP()
    
    def AGFlat2z3(self,pFaux,VarQ,krip,s,fout,D) :  # ecrit sur fout une liste (conj) de formules propo pour coder les def de AG(p<=> def)
        f1=self.fils[0]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        fp=AP(pFaux)
        for st in krip.accessibles[s] :
            fout.write("(=> ")     # => vs <=>  
            fp.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(" (and ")
            f1.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(" ")
            if len(krip.succ[st])==1 :
                for stp in krip.succ[st] : 
                    fp.FFlat2z3(VarQ,krip,stp,fout,D)
            else :
                fout.write("(or ")
                for stp in krip.succ[st] :
                    fp.FFlat2z3(VarQ,krip,stp,fout,D)
                    fout.write(" ")
                fout.write(")")
            fout.write("))")
        fout.write("\n")
        
    def FFlat2z3(self,PBool,PBT,VarQ,krip,stp) :
        print("Warning ! FFlat2z3 ne devrait pas etre appele sur "+str(type(self)))
        
    def FNN(self,np,opeq=False) :
        f=self.fils[0].FNN(np,opeq)
        if np :
            return AF(f)
        else :
            return EG(f)

    def Size(self) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(lq=0)
        return (t+1,ht+1,nba,nbqv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (EG in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return self
    
###############################################################################
#                          AG
###############################################################################
class AG :
    def __init__(self, a) :
        self.fils=[a]

    def toString(self) :
        return "AG ("+self.fils[0].toString()+")"
#        return "(AG "+self.fils[0].toString()+")"

    def SimplifB(self) :
        f=self.fils[0].SimplifB()
        if isinstance(f,TOP) or isinstance(f,BOTTOM)  :
            return f
        else:
            return AG(f)

    def toQCIR(self,gatestab,fout,qblock =False,ng=None) :
        print("Warning ! toQCIR is not defined for AG ! ")
        return ""

    def toZ3(self,fout) :
        print("Warning ! toZ3 not defined for AG ! ")
        
    def PropQuant(self) : 
        return self.fils[0].PropQuant()

    def nbalt(self,t = None) :
#        print('Erreur : calcul du nb d alternations pour une formule QCTL !')
        return self.fils[0].nbalt(t)
        

    def isPNF(self,niveau) :
        return self.fils[0].isPNF(False)

    def MaPl(self,D,Df,niv,justeX = 0) :
        if isinstance(self.fils[0],IMPL) :
            a1 =self.fils[0].fils[0]
            a2 =self.fils[0].fils[1]
            if isliteral(a1) and  a2.isCBEAXap(False) :  # cas AG (p => EX q) : on laisse ! 
                return self
                                                 
        f1 = self.fils[0].MaPl(D,Df,1,justeX)
        if niv==-1 :
            return AuxMaPl(AG(f1),D,Df)
#        elif niv==0 and not justeX: # MODIF V1.1 -> supprimer le "and not justeX" 
        elif niv==0 : 
            return AG(f1)
        else : 
            aux=AG(f1)
            index=aux.toString()
            if index in D :
                prop = D[index]
            else :
                prop = getIdent()
                D[index]=prop
                Df[index]=aux
        return AP(prop)

    def AjoutUniq(self,PNF,Lqv) : 
        if PNF and len(Lqv)==0 :
            return AG(self.fils[0])
        elif PNF :
            return MiseEnFormeUniq(self,Lqv)
        else : # pas PNF : on descend...
            f1 = self.fils[0].AjoutUniq(PNF,Lqv)
            return AG(f1)
        
    def FPT(self) :
        return AG(self.fils[0].FPT())


    def AjoutListConj(self,Lc) :
        Lc.append(self)
        return AND(Lc)

    def AjoutPropQuant(self,L,p=None) :
        if p==None : 
            return EXISTS(L,self)
        else :
            return EXISTS(L,FORALL([p],self))
        
    def QcirReduc(self,p,VarQ,version,pq=None) :
        return AG(IMPL(AP(p),AND([self.fils[0],AX(AP(p))])))

    def toQBF(self,rp,krip,s) :
        VarQ, VarQone, QBVvarpf, ku, kea, met, ea1 = rp.BQProp, rp.QPropEA, rp.BVQProppf, rp.Kpf, rp.Kea, rp.method, rp.codageEA1
        if len(krip.accessibles[s])==1 :
            for sp in krip.accessibles[s] : 
              if s != sp :
                print('error in toQBF/AG : s is not reachable from itself ?!')
                return TOP()
              return self.fils[0].toQBF(rp,krip,s)
        if met=='FBV' and isinstance(self.fils[0],IMPL) : # il faut traiter le pppf dans le AG !!
                tp = str(type(self.fils[0].fils[1]))[16:-2]                
                print("FBV : AG (.. => ?) avec ?=",tp)
                if tp == 'EU' :
                    p0=self.fils[0].fils[0] # partie g du IMPL
                    assert(isinstance(p0,AP))
                    p0s=p0.ap
                    land=[]
                    f1=self.fils[0].fils[1].fils[0] # partie g du EU
                    f2=self.fils[0].fils[1].fils[1] # partie d du EU
                    for st in krip.accessibles[s] :
                        p0st=p0s+"_"+Kripkestring_of_state(st)
                        land.append(IMPL(BVgeneTestaZerov(p0st,ku),f2.toQBF(rp,krip,st)))
                        for d in range(1,krip.BUntil) :
                            lor=[]
                            for stp in krip.succ[st] :
                              if not stp == st :
                                p0stp=p0s+"_"+Kripkestring_of_state(stp)     # VERIFIER ! 
                                lor.append(BVcompEgalv(p0stp,d-1,ku))
                            land.append(IMPL(BVcompEgalv(p0st,d,ku),AND(f1.toQBF(rp,krip,st),OR(lor))))
                    return AND(land)
                elif tp == 'AU' :
                    print("toQBF / AG/ AU to be done !")
                    p0=self.fils[0].fils[0] # partie g du IMPL
                    assert(isinstance(p0,AP))
                    p0s=p0.ap
                    land=[]
                    f1=self.fils[0].fils[1].fils[0] # partie g du EU
                    f2=self.fils[0].fils[1].fils[1] # partie d du EU
                    for st in krip.accessibles[s] :
                        p0st=p0s+"_"+Kripkestring_of_state(st)
                        land.append(IMPL(BVgeneTestaZerov(p0st,ku),f2.toQBF(rp,krip,st)))
                        for d in range(1,krip.BUntil) :
                            laux=[f1.toQBF(rp,krip,st)]
                            for stp in krip.succ[st] :
                                p0stp=p0s+"_"+Kripkestring_of_state(stp)      # VERIFIER !
                                laux.append(BVcompInfv(p0stp,d,ku))
                            land.append(IMPL(BVcompEgalv(p0st,d,ku),AND(laux)))  
                    return AND(land)
                elif tp == 'EF' :
                    p0=self.fils[0].fils[0] # partie g du IMPL
                    assert(isinstance(p0,AP))
                    p0s=p0.ap
                    land=[]
                    f1=self.fils[0].fils[1].fils[0] # partie d du EF
                    for st in krip.accessibles[s] :
                        p0st=p0s+"_"+Kripkestring_of_state(st)
                        land.append(IMPL(BVgeneTestaZerov(p0st,ku),f1.toQBF(rp,krip,st)))
                        for d in range(1,krip.BUntil) :
                            lor=[]
                            for stp in krip.succ[st] :
                              if not stp == st :
                                p0stp=p0s+"_"+Kripkestring_of_state(stp)     # VERIFIER ! 
                                lor.append(BVcompEgalv(p0stp,d-1,ku))
                            land.append(IMPL(BVcompEgalv(p0st,d,ku),OR(lor)))
                    return AND(land)
                elif tp == 'AF' :
                    p0=self.fils[0].fils[0] # partie g du IMPL
                    assert(isinstance(p0,AP))
                    p0s=p0.ap
                    land=[]
                    f1=self.fils[0].fils[1].fils[0] # partie d du AF
                    for st in krip.accessibles[s] :
                        p0st=p0s+"_"+Kripkestring_of_state(st)
                        land.append(IMPL(BVgeneTestaZerov(p0st,ku),f1.toQBF(rp,krip,st)))
                        for d in range(1,krip.BUntil) :
                            laux=[]
                            for stp in krip.succ[st] :
                                p0stp=p0s+"_"+Kripkestring_of_state(stp)     # VERIFIER ! 
                                laux.append(BVcompInfv(p0stp,d,ku))
                            land.append(IMPL(BVcompEgalv(p0st,d,ku),AND(laux)))
                    return AND(land)
                else : # appliquer AG... comme AND (...)
                    pass
        L=[]
        for st in krip.accessibles[s] :
            f = self.fils[0].toQBF(rp,krip,st)
            L.append(f)
        return AND(L)
    
    def AGFlat2z3(self,pFaux,VarQ,krip,s,fout,D) :  # ecrit sur fout une liste (conj) de formules propo pour coder les def de AG(p<=> def)
        f1=self.fils[0]    # pour tout st on doit avoir: p_phi_st <-> \/_{st->st'} p_f1_st'
        fp=AP(pFaux)
        for st in krip.accessibles[s] :
            fout.write("(=> ")    # => vs <=>
            fp.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(" (and ")
            f1.FFlat2z3(VarQ,krip,st,fout,D)
            fout.write(" ")
            if len(krip.succ[st])==1 :
                for stp in krip.succ[st] : 
                    fp.FFlat2z3(VarQ,krip,stp,fout,D)
            else :
                for stp in krip.succ[st] :
                    fp.FFlat2z3(VarQ,krip,stp,fout,D)
                    fout.write(" ")
            fout.write("))")
        fout.write("\n")
        
    def FFlat2z3(self,VarQ,krip,st,fout,D) :    #MODIF V1.1 -> renvoyer la conjonction sur tous les etats !
#        print("Warning ! FFlat2z3 ne devrait pas etre appele sur "+str(type(self)))
        f1=self.fils[0]
        if len(krip.accessibles[st])==1 :
                for stp in krip.accessibles[st] : 
                        f1.FFlat2z3(VarQ,krip,stp,fout,D)
        else :
            fout.write("(and ")
            for stp in krip.accessibles[st] :# on doit avoir:  /\_{st->*st'} p_f1_st' 
                f1.FFlat2z3(VarQ,krip,stp,fout,D) 
            fout.write(")")
            
    def FNN(self,np,opeq=False) :
        f=self.fils[0].FNN(np,opeq)
        if np :
            return EF(f)
        else :
            return AG(f)

    def Size(self,lq=0) : # return (ht,nba,nbqvar)
        (t,ht,nba,nbqv) = self.fils[0].Size(lq)
        return (t+1,ht+1,nba,nbqv)

    def isCBEAXap(self,dejavuX) :  # retourne T ssi (dejavuX=F ^ self=CB de EX/AX de ht=1) v (dejavuX=T ^self=CB de ap)
        return False

    def ContainsOP(self,L) :
        if (AG in L) :
            return True
        return self.fils[0].ContainsOP(L)

    def TraitementEUAUAF(self,prop) :
        return self
    
########################################################################

global countAtLeast
countAtLeast=0

def incAtLeast() :
    global countAtLeast
    countAtLeast+=1
    return countAtLeast

# Exprime le fait qu'au moins bound successeurs satisfont formule.
def getXAtLeast(bound, formule) :
    if bound == 0 :
        return TOP()
    if bound == 1 :
        return EX(formule)
    global countAtLeast
    tmp=countAtLeast
    
    # La i-eme variable quantifiee qu'on utilisera.
    def getIdent(i) :
        return "atLeast_"+str(i+tmp)
    
    # Un bloc de i quantificateurs existentiels devant f.
    def putExists(i, f) :
        if i == 0 :
            return f
        var=[]
        for j in range(i) :
            var.append(getIdent(j+1))
        return EXISTS(var, f)
    
    log=(bound-1).bit_length()
    for j in range(log) :
        incAtLeast()
        
    # Une formule qui exprime qu'on se trouve dans le i-eme successeur satisfaisant formule.
    def getConj(i) :
        ans=[formule]
        # Ecriture de i en base 2.
        for j in range(log) :
            if i%2 == 0 :
                ans.append(NOT(AP(getIdent(j+1))))
            else :
                ans.append(AP(getIdent(j+1)))
            i=i//2
        return AND(ans)
    
    ans=[]
    for i in range(bound) :
        ans.append(EX(getConj(i)))
    return putExists(log, AND(ans))

# Exprime le fait qu'au moins bound accessibles satisfont formule.
def getFAtLeast(bound, formule) :
    if bound == 0 :
        return TOP()
    if bound == 1 :
        return EF(formule)
    global countAtLeast
    tmp=countAtLeast

    # La i-eme variable quantifiee qu'on utilisera.
    def getIdent(i) :
        return "atLeast_"+str(i+tmp)

    # Un blocde i quantificateurs existentiels devant f.
    def putExists(i, f) :
        if i == 0 :
            return f
        var=[]
        for j in range(i) :
            var.append(getIdent(j+1))
        return EXISTS(var, f)
        
    log=(bound-1).bit_length()
    for j in range(log) :
        incAtLeast()

    # Une formule qui exprime que l'on se trouve dans le i-eme accessible satisfaisant formule.
    def getConj(i) :
        ans=[formule]
        # Ecriture de i en base 2.
        for j in range(log) :
            if i%2 == 0 :
                ans.append(NOT(AP(getIdent(j+1))))
            else :
                ans.append(AP(getIdent(j+1)))
            i=i//2
        return AND(ans)

    ans=[]
    for i in range(bound) :
        ans.append(EF(getConj(i)))

    return putExists(log, AND(ans))

# Exprime le fait qu'exactement n successeurs satisfont formule.
def getXExactly(n, formule) :
    return AND(getXAtLeast(n, formule), NOT(getXAtLeast(n+1, formule)))

# Exprime le fait qu'exactement n accessibles satisfont formule.
def getFExactly(n, formule) :
    return AND(getFAtLeast(n, formule), NOT(getFAtLeast(n+1, formule)))

# Une fonction qui calcule par memoisation le nombre de noeuds de l'AST d'une formule.

tmp={}

def findLength(formule) :
    global tmp
    if formule in tmp :
        return tmp[formule]
    ans=1
    for fils in formule.fils :
        ans+=findLength(fils)
    tmp[formule]=ans
    return ans

# fct pour la mise a plat: on renvoie la formule:
# Exists[p1... pk]. f ^  /\_i AG (pi <=> Fi])   avec D[Fi]=pi

# D associe une prop a une string d'une formule
# Df associe une formule  a une string (de cette formule)
def AuxMaPl(f,D,Df) :
    if len(D)==0 :
        return f
    Lres = [f]
    Lprop = [ ]
    for fi in D :
        Lres.append(AG(EQ(AP(D[fi]),Df[fi])))  # pb: ici on veut la formule fi [pas la (string) fi] !!
        Lprop.append(D[fi])
    Fres = EXISTS(Lprop,AND(Lres))
    return Fres


##########################################################
#  Codage des Bit vectors

import math

def BVgeneBV(s,k) :
    return  [s+"_"+str(i) for i in range(k)]

# retourne la liste des booleens correspondant a v (ordre: bit de poids faible en premier... a gauche !)
def BVgeneValBVs(v,k) :
    vb=bin(v)[2:]
    addzero = k-len(vb)
    if addzero < 0 :
        print("Warning ! BitVec have not the right size ! val :",v," (",len(vb),") instead of ",k)
    vb= ('0'*addzero)+vb
    lv=list(vb)
    lv.reverse()  # on met le bit de poids faible en tete
    return lv

def BVgeneValBVb(v,k) :
    vb=bin(v)[2:]
    addzero = k-len(vb)
    if addzero < 0 :
        print("Warning ! BitVec have not the right size ! val :",v," (",len(vb),") instead of ",k)
    vb= ('0'*addzero)+vb
    lv=list(vb)
    lv.reverse()
    lres=[]
    for v in lv :
        if v=='1' :
            lres.append(True)
        else :
            lres.append(False)
    return lres

    
def BVgeneTestaZero(bv) :
    L = [NOT(AP(x)) for x in bv]
    return AND(L)

def BVgeneTestaZerov(x,k) :
    bv=BVgeneBV(x,k)
    L = [NOT(AP(x)) for x in bv]
    return AND(L)

def BVcompEgalbv(bx,by) :
    assert(len(bx)==len(by))
    L=[]
    for i in range(len(bx)) :
        L.append(EQ(AP(bx[i]),AP(by[i])))
    return AND(L)

def BVcompEgal(bx,val) :
    k=len(bx)
    lval=BVgeneValBVb(val,k)
    L=[]
    for i in range(k) :
        if lval[i] :
            L.append(AP(bx[i]))
        else :
            L.append(NOT(AP(bx[i])))
    return AND(L)

def BVcompEgalv(x,val,k) :
    bx = BVgeneBV(x,k)
    return BVcompEgal(bx,val)

def BVcompInf(bv,val) :
    k=len(bv)
    lval=BVgeneValBVb(val,k)
    Lor = []
    for i in range(k) :
        Land=[]
        if lval[i] :
            Land.append(NOT(AP(bv[i])))
            for j in range(i+1,k) :
                if lval[j] :
                    Land.append(AP(bv[j]))
                else :
                    Land.append(NOT(AP(bv[j])))
            Lor.append(AND(Land))
    return OR(Lor)

def BVcompInfE(bv,val) :
    k=len(bv)
    lval=BVgeneValBVb(val,k)
    Lor = []
    for i in range(k) :
        Land=[]
        if lval[i] :
            Land.append(NOT(AP(bv[i])))
            for j in range(i+1,k) :
                if lval[j] :
                    Land.append(AP(bv[j]))
                else :
                    Land.append(NOT(AP(bv[j])))
            Lor.append(AND(Land))
    egal=BVcompEgal(bv,val)
    Lor.append(egal)
    return OR(Lor)

def BVcompInfv(x,val,k) :
    bx = BVgeneBV(x,k)
    return BVcompInf(bx,val)

def BVcompInfEv(x,val,k) :
    bx = BVgeneBV(x,k)
    return BVcompInfE(bx,val)

########################################################################
#             FCT for UU encoding (called from toQBF methods)
#toQBF(self,rp,krip,s)
def auxUU_EU(F,rp,krip,s,Lvus) :
    f1,f2 = F.fils[0],F.fils[1]
    f1s,f2s = f1.toQBF(rp,krip,s),f2.toQBF(rp,krip,s)
    if len(Lvus) < krip.BUntil :
        Lvus2=Lvus[:]
        Lvus2.append(s)
        if len(krip.succ[s])==1 :
                for stp in krip.succ[s] :
                    if stp not in Lvus2 : 
                        auxF= auxUU_EU(F,rp,krip,stp,Lvus2)
                    else :
                        auxF=BOTTOM()
        else :
            Lor=[]
            for stp in krip.succ[s] :
                if stp not in Lvus2 : 
                    Lor.append(auxUU_EU(F,rp,krip,stp,Lvus2))
            if len(Lor)==0 :
                auxF = BOTTOM()
            else : 
                auxF = OR(Lor)
        return OR(f2s,AND(f1s,auxF))
    else :
        return f2s
        
def auxUU_AU(F,rp,krip,s,Lvus) :
    f1,f2 = F.fils[0],F.fils[1]
    f1s,f2s = f1.toQBF(rp,krip,s),f2.toQBF(rp,krip,s)
    if len(Lvus) < krip.BUntil :
        Lvus2=Lvus[:]
        Lvus2.append(s)
        if len(krip.succ[s])==1 :
                for stp in krip.succ[s] :
                    if stp in Lvus2 : 
                        return f2s
                    else :
                        auxF= auxUU_AU(F,rp,krip,stp,Lvus2)
                        return OR(f2s,AND(f1s,auxF))
        else :
            Land=[]
            for stp in krip.succ[s] :
                if stp in Lvus2 :
                    return f2s
                else :
                    Land.append(auxUU_AU(F,rp,krip,stp,Lvus2))
            if len(Land)==0 :
                return OR(f2s,f1s)
            else :
                Land.append(f1s)
                return OR(f2s,AND(Land))
    else :
        return f2s


def auxUU_EW(F,rp,krip,s,Lvus) :
    f1,f2 = F.fils[0],F.fils[1]
    f1s,f2s = f1.toQBF(rp,krip,s),f2.toQBF(rp,krip,s)
    if len(Lvus) < krip.BUntil :
        Lvus2=Lvus[:]
        Lvus2.append(s)
        if len(krip.succ[s])==1 :
                for stp in krip.succ[s] :
                    if stp not in Lvus2 : 
                        return OR(f2s,AND(f1s,auxUU_EW(F,rp,krip,stp,Lvus2)))
                    else :
                        return OR(f2s,f1s)
        else :
            Lor=[]
            for stp in krip.succ[s] :
                if stp  in Lvus2 :
                     return OR(f2s,f1s)
                else :
                     Lor.append(auxUU_EW(F,rp,krip,stp,Lvus2))
            return OR(f2s,AND(f1s,OR(Lor)))
    else :
        return f2s
        
def auxUU_AW(F,rp,krip,s,Lvus) :
    f1,f2 = F.fils[0],F.fils[1]
    f1s,f2s = f1.toQBF(rp,krip,s),f2.toQBF(rp,krip,s)
    if len(Lvus) < krip.BUntil :
        Lvus2=Lvus[:]
        Lvus2.append(s)
        if len(krip.succ[s])==1 :
                for stp in krip.succ[s] :
                    if stp  in Lvus2 : 
                        return OR(f2s,f1s)
                    else :
                        auxF= auxUU_AW(F,rp,krip,stp,Lvus2)
                        return OR(f2s,AND(f1s,auxF))
        else :
            Land=[]
            for stp in krip.succ[s] :
                if stp not in Lvus2 :
                    Land.append(auxUU_AW(F,rp,krip,stp,Lvus2))
            if len(Land)==0 :
                return OR(f2s,f1s)
            else :
                Land.append(f1s)
                return OR(f2s,AND(Land))
    else :
        return f2s


def auxUU_EG(F,rp,krip,s,Lvus) :
    f1 = F.fils[0]
    f1s = f1.toQBF(rp,krip,s)  
    if len(Lvus) < krip.BUntil :
        Lvus2=Lvus[:]
        Lvus2.append(s)
        if len(krip.succ[s])==1 :
                for stp in krip.succ[s] :
                    if stp not in Lvus2 : 
                        return AND(f1s,auxUU_EG(F,rp,krip,stp,Lvus2))
                    else :
                        return f1s
        else :
            Lor=[]
            for stp in krip.succ[s] :
                if stp  in Lvus2 :
                     return f1s
                else :
                     Lor.append(auxUU_EG(F,rp,krip,stp,Lvus2))
            return AND(f1s,OR(Lor))
    else :
        return BOTTOM()
        
def auxUU_AF(F,rp,krip,s,Lvus) :
    f1 = F.fils[0]
    f1s = f1.toQBF(rp,krip,s)  
    if len(Lvus) < krip.BUntil :
        Lvus2=Lvus[:]
        Lvus2.append(s)
        if len(krip.succ[s])==1 :
                for stp in krip.succ[s] :
                    if stp in Lvus2 : 
                        return f1s
                    else :
                        auxF= auxUU_AF(F,rp,krip,stp,Lvus2)
                        return OR(f1s,auxF)
        else :
            Land=[]
            for stp in krip.succ[s] :
                if stp in Lvus2 :
                    return f1s
                else :
                    Land.append(auxUU_AF(F,rp,krip,stp,Lvus2))
            return OR(f1s,AND(Land))
    else :
        return f1s
