import os
import main

#from colorama import Fore, Back, Style

from structure import *


# To save a Kripke structure (S,R,l) in a file
def KStoQCTLmodele(K,nomfich) :
    S=K[0]
    A=K[1]
    L=K[2]
    fout = open(nomfich,'w')
    fout.write('states')
    nbpl=10
    for s in S :
        if nbpl < 10 :
            fout.write(', ')
        else :
            fout.write('\n')
            nbpl=0
        if len(L[s]) == 0 :
            fout.write(s)
        else :
            ls = L[s][0]
            for i in range(1,len(L[s])) :
                ls+=','+L[s][i]
            fout.write(s+' : {'+ls+'}')
        nbpl+=1
    fout.write('\ntransitions\n')
    for s in S :
        if len(A[s]) > 0 :
            slsucc = A[s][0]
            for i in range(1,len(A[s])) :
                slsucc += ' | '+A[s][i]
            fout.write(s+" -> "+slsucc+'\n')
    fout.write('end\n')
    fout.close()

    
#################################################################
#
#            NIM GAME
#
#################################################################

def geneConfigL(L,k) :
    if len(L)==k :
        return [[]]
    Laux =  geneConfigL(L,k+1)
    Lres=[]
    for laux in Laux : 
        for v in range(L[k],-1,-1) :
            l = laux[:]
            l.append(v)
            Lres.append(l)
    return Lres
            
        

def geneConfigNim(L) :
    Lc = geneConfigL(L,0)
    Sres=[]
    for lc in Lc :
        lc.sort()
        for i in [1,2] :
            cs = NimConf(lc,i)
            if cs not in Sres :
                Sres.append(cs)
    return Sres

def NimConf(T,J) :
    res = str(T[0])
    for v in T[1:] :
        res+="_"+str(v)
    res+="_"+str(J)
    return res

def NimDeconf(c) :
    l=c.split("_")
    return [int(v) for v in l]

def NimFin(cs) : # cs est la liste des val de chaque tas
    for v in cs :
        if v>0 :
            return False
    return True
    
# construit un jeu de Nim: L donne la liste des tas de depart (le nb d'allumettes initial)
# un etat est une config de tas et un entier indiquant le trait (1 ou 2)
# j est le joeur pour lequel on marquera la strat... cela change ses transitions 
def JNim(L,joueur) :
    n = len(L)
    S = geneConfigNim(L)
    R = { }
    Sint = []
    for s in S :
        R[s]=[]
        cs = NimDeconf(s)
        j=cs[-1]
        cs=cs[:-1]
        if j != joueur :
            for k in range(len(cs)):
                for v in range(1,cs[k]+1) :
                    newc = cs[:]
                    newc[k]=newc[k]-v
                    newc.sort()
                    news=NimConf(newc,joueur)
                    R[s].append(news)
            if NimFin(cs) :
                R[s].append(s)
        else :
            if joueur == 1 :
                jaux=2
            else :
                jaux=1
            for k in range(len(cs)):
                for v in range(1,cs[k]+1) :
                    newc = cs[:]
                    newc[k]=newc[k]-v
                    newc.sort()
                    news=NimConf(newc,jaux)
                    Sint.append('int'+s+"_"+news)
                    R[s].append('int'+s+"_"+news)
                    R['int'+s+"_"+news]=[news]
            if NimFin(cs) :
                Sint.append('int'+s+"_"+s)
                R[s].append('int'+s+"_"+s)
                R['int'+s+"_"+s]=[s]
    S.extend(Sint)
    l={}
    fin='0'+('_0'*(n-1))
    for s in S :
        if s[0:3]=='int' :
            l[s] = ['inter']
        else :
            if s[:-2] == fin :
                if s[-1]=='1' :
                    l[s]=['win2','trait1'] # il faut prendre la derniere allumettes pour gagner
                else :
                    l[s]=['win1','trait2']
            else :
                if s[-1]=='1' :
                    l[s]=['trait1'] 
                else :
                    l[s]=['trait2']
    # reduction aux seuls etats accessibles...
    sinit=S[0]
    Sres=[]
    Rres={ }
    lres={ }
    Attente = [sinit]
    while len(Attente)>0 :
        s=Attente.pop()
        lres[s] = l[s]
        Sres.append(s)
        for saux in R[s] :
            if (saux not in Sres) and (saux not in Attente) :
                Attente.append(saux)
    print('Il y a ',str(len(Sres)),' etats dans le modele.')
    for s in Sres :
        Rres[s]=[]
        for saux in R[s] :
            if saux in Sres :
                Rres[s].append(saux)    
    return (Sres,Rres,lres)



# renvoie le gagnant (le gagnant est celui prend la derniere allumette)
def NimQuiGagne(L) :
    Lbin = [ ]
    maxl=0
    for v in L :
        vb=bin(v)[2:]
        lvb=[int(x) for x in vb]
        maxl =max(maxl,len(lvb))
        Lbin.append(lvb)
        print(lvb)
    print("max l = ",maxl)
    for i in range(maxl) :
        s=0
        for l in Lbin :
            if len(l) > 0 :
                s+= l.pop()
        if s%2 == 1 :
            print("J1 gagne !")
            return 1
    print("J2 gagne !")
    return 2


Ltnim = [([2,2],1), ([3,2],1), ([3,4,5],1), ([4,5,2],1), ([2,4,8,14],1)]
                
def testNim(L,joueur,met,ea,solver,bu=0) :
        print("Nim game - initial configuration :"+str(L))
        print("Player ",str(joueur))
        print("Method ",met)
#        F=parserF.read_formula('NIMG/nimF')
        print("-----------------------------------------------------")
        foutKnim = "K"
        for v in L:
            foutKnim = foutKnim+"_"+str(v)
        foutKnim = foutKnim+"_J"+str(joueur)
        if os.path.isfile('NIMG/'+foutKnim) :
                print("Model already exists... file:"+'NIMG/'+foutKnim)
#                os.system("rm NIMG/"+foutKnim)
                K=Krip.from_file('NIMG/'+foutKnim,bu)
        else :
                print("Construction of the model... file:"+'NIMG/'+foutKnim)
                K = JNim(L,joueur)
                KStoQCTLmodele(K,'NIMG/'+foutKnim)
                K=Krip.from_file('NIMG/'+foutKnim,bu)
        print("-----------------------------------------------------")
        #print("NEGATION DE L AFORMULE !")
        F=main.read_formula('NIMG/nimF'+str(joueur))
        fichname='NIMG/'+foutKnim+met+'_'+str(ea)
        res=main.Verif(F,K,fichname,met,ea,solver)
#        main.verif(foutKnim,'nimF'+str(joueur),'NIMG/',met,bu)
        # print("====")
        # print("Verification...")
        # res=NimQuiGagne(L)
        # if (res==1 and joueur==1) or (res==2 and joueur==2) : 
        #     print("The result should be SAT !")
        # else :
        #     print("The result should be UNSAT !")



# Function to launch a list of tests:
def SerieTestNim(LJ,met,bu=0) :
        for (L,j) in LJ :
                print("************** ",str(met)," ************************")
                print("Test : Nim game for ",str(L)," and Player ",str(j))
                testNim(L,j,met,bu)


#################################################################
#
#             "strongly connected components"
#
#################################################################

def K_SCC(n,k) :
    S,A,L=[ ],{ },{ }
    # construction des etats:
    S=['r']
    S1 = ['q_'+str(i)+'_'+str(j) for i in range(n) for j in range(k)]
    S.extend(S1)
    # construction de slabels
    for s in S :
        L[s]=[ ]
        A[s] = [ ]
    # construction des transitions:
    for i in range(n) :
        A['r'].append('q_'+str(i)+'_0')
        for j in range(k) :
            A['q_'+str(i)+'_'+str(j)].append('q_'+str(i)+'_'+str((j+1)%k))
    print("There are "+str(len(S))+" states in the model.")
    return (S,A,L)

def testSCC(n,k,kf,met,ea,solver,bu=0) :
        assert(kf>0)
        print("Checking for "+str(kf)+" states reachable from every state in  S",str(n),"_",str(k))
        print("Methode ",met)
        print("Construction of the formula...")
        lqv = "p0 "
        fou = "p0"
        for i in range(1,kf) :
                lqv=lqv+", p"+str(i)+" "
                fou = fou + " | p"+str(i)+" "
        F=main.getF("Ex1 "+lqv+". AG EF ("+fou+")")
        print(F.toString())
        foutKconnect="K"+str(n)+"_"+str(k)
        if os.path.isfile('KSCC/'+foutKconnect) :
            print("This model already exists.")
        else :
            print("Construction of the model...")
            K = K_SCC(n,k)
            KStoQCTLmodele(K,'KSCC/'+foutKconnect)
        print("-----------------------------------------------------")
        #main.verif(foutKconnect,foutFconnect,'KCONNECT/',met,bu)
        K=Krip.from_file('KSCC/'+foutKconnect,bu)
        fichname="KSCC/K_"+str(n)+"_"+str(k)+"_"+str(kf)+"_"+met+"_"+str(ea)
        res=main.Verif(F,K,fichname,met,ea,solver)
        return res


def SerieTestSCC(L,Lmet,ea,Lsolver,autotest,bu=0) :
    global AUTOTEST
    AUTOTEST=autotest
    for (n,k,kf) in L :
        main.PrintCol("SCC -- parametres : "+str(n)+" / "+str(k)+" / "+str(kf),'GREEN')
        if n <= kf :
            resatt=True
            main.PrintCol("should be SAT",'GREEN')
        else :
            resatt=False
            main.PrintCol("should be UNSAT",'RED')
        for met in Lmet :
            main.PrintCol("Methode :"+met,'CYAN')
            for s in Lsolver :
                res=testSCC(n,k,kf,met,ea,s,bu)
                if autotest :
                    if res != resatt :
                        main.PrintCol("Probleme !! "+str(res)+" / "+str(resatt),'RED')

#Lscc=[(4,10,5),(4,10,3),(8,20,7),(8,20,8)]

        

        
#################################################################
#
#             K-CONNECTIVITY
#
#################################################################
def GrilleConf(i,j) :
    return "q"+str(i)+"_"+str(j)

def grilleKS(n,m) :
    S = [GrilleConf(i,j) for i in range(m) for j in range(n)]
    L = { }
    R = { } 
    for i in range(m) :
        for j in range(n) :
            ni = (i+1)%m
            nj = (j+1)%n
            R[GrilleConf(i,j)] = [ GrilleConf(i,nj), GrilleConf(ni,j) ] 
            L[GrilleConf(i,j)] = [ ]
    print("There are "+str(len(S))+" states in the model.")
    return (S,R,L)
            
        

# construit une structure basee sur deux sous-grilles de taille nxn avec k passerelles... donc k chemins entre
# l'entree q_0,0 et la sortie r_n-1,n_1
# gno = True ssi tous les arcs sont doubles (graphe non oriente)
def KSkconnexe(n,k,gno = False) :
    assert((2*n-1)>=k)
    S,A,L=[ ],{ },{ }
    # construction des etats:
    S = ['q_'+str(i)+'_'+str(j) for i in range(n) for j in range(n)]
    S1 = ['r_'+str(i)+'_'+str(j) for i in range(n) for j in range(n)]
    S.extend(S1)
    #construction des labels (on ne tag que l'entree et la sortie:
    for s in S :
        if s=='q_0_0' :
            L[s]=['e']
        elif s=='r_'+str(n-1)+'_'+str(n-1) :
            L[s]=['s']
        else :
            L[s]=[ ]
    # construction des arcs:
    for i in range(n) :
        for j in range(n) :
            src = 'q_'+str(i)+'_'+str(j)
            src2 = 'r_'+str(i)+'_'+str(j)
            ldest,ldest2 = [ ],[ ]
            if j < n-1 :
                ldest.append('q_'+str(i)+'_'+str(j+1))
                ldest2.append('r_'+str(i)+'_'+str(j+1))
            if i < n-1 :
                ldest.append('q_'+str(i+1)+'_'+str(j))
                ldest2.append('r_'+str(i+1)+'_'+str(j))
            A[src] = ldest
            A[src2] = ldest2
    # on complete depuis q_0_0 et vers r_n-1_n-1
    for i in range(2,n) :
        A['q_0_0'].append('q_0_'+str(i))
        A['q_0_0'].append('q_'+str(i)+'_0')
        A['r_'+str(n-1)+'_'+str(i-2)].append('r_'+str(n-1)+'_'+str(n-1))
        A['r_'+str(i-2)+'_'+str(n-1)].append('r_'+str(n-1)+'_'+str(n-1))
    # construction des passerelles :
    k1=(k-1)//2  # en "haut"
    k2=k-1-k1    # en bas
    A['q_'+str(n-1)+'_'+str(n-1)].append('r_0_0')
    if k1 > 0 : 
        step1 = (n-1) // k1 
        for p in range(k1) :
            A['q_'+str(n-1)+'_'+str(p*step1)].append('r_'+str(n-1-p*step1)+'_0')
    if k2 > 0 : 
        step2 = (n-1) // k2 
        for p in range(k2) :
            A['q_'+str(p*step2)+'_'+str(n-1)].append('r_0_'+str(n-1-p*step2))

    if gno :
        # on dedouble tous les arcs...
        Ares = { }
        for s in S :
            Ares[s] = [ ]
        for s1 in S :
            for s2 in A[s1] :
                Ares[s1].append(s2)
                Ares[s2].append(s1)
        A=Ares
        
    return (S,A,L)

    
def KconnectUntilV2(i,k,fout,propend) :
        fout.write("(EX E  ( ")
        for j in range(1,k) :
                if j!=i :
                        fout.write("!")
                fout.write("p"+str(j)+" ")
                if j<k-1 :
                        fout.write("& ")
        fout.write(") U "+propend+")")
        
# n,k -> parametres du modele
# kf : le k de la formule (teste la k-connexite)
# vf = version dde la formule: 1 pour All1... et 2 pour Ex p1...
# vf=3 pour la 1 generalisee (on verifie la prop pour depuis tout sommet accessible)
# vf=4 pour la 2 generalisee (...)
def testKconnect(n,k,kf,vf,met,ea,solver,bu=0) :
        print("Checking for "+str(kf)+"-connectivity for S",str(n),"_",str(k))
        print("Methode ",met)
        print("Construction of the formula...")
        foutFconnect="F"+str(kf)+"_V"+str(vf)
#        if os.path.isfile('KCONNECT/'+foutFconnect) :
#                #print("on supprime le vieux fichier...")
#                if os.name != 'nt' :
#                	os.system("rm KCONNECT/"+foutFconnect)
#                else :
#                	os.system("del KCONNECT\\"+foutFconnect)
        Fout=open('KCONNECT/'+foutFconnect,'w')
        if vf==1 : 
                Fout.write("Al1 p1")
                for i in range(2,kf) :
                        Fout.write(", p"+str(i))
                Fout.write(". (EX E (!p1 ")
                for i in range(2,kf) :
                        Fout.write("& !p"+str(i))
                Fout.write(") U s)\n")
        elif vf==2 :
                Fout.write("Ex p1")
                for i in range(2,kf) :
                        Fout.write(", p"+str(i))
                Fout.write(".[")
                KconnectUntilV2(0,kf,Fout,"s")
                for i in range(1,kf) :
                        Fout.write(" & ")
                        KconnectUntilV2(i,kf,Fout,"s")
                Fout.write("]\n")
        elif vf==3 :
                Fout.write("Al1 y, p1")
                for i in range(2,kf) :
                        Fout.write(", p"+str(i))
                Fout.write(". [AG [EX E  (!p1 ")
                for i in range(2,kf) :
                        Fout.write("& !p"+str(i))
                Fout.write(") U y]]\n")
        else :
                Fout.write("Al1 y . Ex p1")
                for i in range(2,kf) :
                        Fout.write(", p"+str(i))
                Fout.write(".[AG ")
                KconnectUntilV2(0,kf,Fout,"y")
                for i in range(1,kf) :
                        Fout.write(" & ")
                        KconnectUntilV2(i,kf,Fout,"y")
                Fout.write("]\n")                
        Fout.close()
        F=main.read_formula('KCONNECT/'+foutFconnect)
#        print(F.toString())
        foutKconnect="K"+str(n)+"_"+str(k)
        if os.path.isfile('KCONNECT/'+foutKconnect) :
            print("This model already exists.")
        else :
            print("Construction of the model... file:"+"KCONNECT/"+foutKconnect)
            K = KSkconnexe(n,k,True)
            KStoQCTLmodele(K,'KCONNECT/'+foutKconnect)
        print("-----------------------------------------------------")
        #main.verif(foutKconnect,foutFconnect,'KCONNECT/',met,bu)
        K=Krip.from_file('KCONNECT/'+foutKconnect,bu)
        fichname="KCONNECT/K_"+str(n)+"_"+str(k)+"_"+str(kf)+"_"+met+"_"+str(ea)
        res=main.Verif(F,K,fichname,met,ea,solver)


#################################################################
#
#             RESOURCES DISTRIBUTION
#
#################################################################
            
def ResourceDisj(kf,Fout) :
        Fout.write("( c1 ")
        for i in range(2,kf+1) :
                Fout.write("| c"+str(i)+" ")
        Fout.write(")")


def SerieTestResource(L,meth) :
        for (n,m,kf,d) in L :
                testResource(n,m,kf,d,meth)
                
def testResource(n,m,kf,d,met,ea,solver) :
        def aux(i) :
            ResourceDisj(kf, Fout)
            Fout.write(" | EX (\n")
            if i==1 :
                ResourceDisj(kf, Fout)
            else :
                aux(i-1)
            Fout.write(")\n")
        print("*****************************************************")
        print("Model ",str(n),"x",str(m))
        print("Find "+str(kf)+" vertices such that every reachable state can reach in at most "+str(d)+" transitions one of these vertices.")
        print("Method ",met)
        print("-----------------------------------------------------")
        print("Construction of the formula...")
        foutFresource="F"+str(kf)+"_"+str(d)
        if os.path.isfile('MAP/'+foutFresource) :
                print("The formula already exists.")
#                os.system("rm MAP/"+foutFresource)
        else :
                Fout=open('MAP/'+foutFresource,'w')
                Fout.write("Ex1 c1")
                for i in range(2,kf+1) :
                   Fout.write(", c"+str(i))
                Fout.write(". AG (")
#                ResourceDisj(kf,Fout)
#                Fout.write("\n")
                aux(d)            
                Fout.write(")\n")
                Fout.close()
#        F=parserF.read_formula('MAP/'+foutFresource)
#        print(F.toString())
        
        foutR="Kres_"+str(n)+"_"+str(m)
        print("Construction of the model... file:"+"MAP/"+foutR)
        if os.path.isfile('MAP/'+foutR) :
                print("The model already exists...")
#                os.system("rm MAP/"+foutR)
        else :
               K = grilleKS(n,m) 
               KStoQCTLmodele(K,'MAP/'+foutR)
        print("-----------------------------------------------------")
        F=main.read_formula('MAP/'+foutFresource)
        K=Krip.from_file('MAP/'+foutR,0)
        fichname='MAP/'+foutR+'_'+str(kf)+"_"+str(d)+'_'+met+'_'+str(ea)
        res=main.Verif(F,K,fichname,met,ea,solver)
        #main.verif(foutR,foutFresource,"MAP/",met)



#################################################################
#
#             RESOURCES DISTRIBUTION 2 : avec un plus grand branchement.
#
#################################################################
def GrilleConf2(i,j) :
    return "q"+str(i)+"_"+str(j)

def grilleKS2(n,m) :
    S = [GrilleConf2(i,j) for i in range(n) for j in range(m)]
    L = { }
    R = { } 
    for i in range(n) :
        for j in range(m) :
#            ni = (i+1)%n
            nj = (j+1)%m
            R[GrilleConf2(i,j)] = [ GrilleConf2(u,nj) for u in range(n) ] 
            L[GrilleConf2(i,j)] = [ ]
    print("There are "+str(len(S))+" states in the model.")
    return (S,R,L)
    
def ResourceDisj2(kf,Fout) :
        Fout.write("( c1 ")
        for i in range(2,kf+1) :
                Fout.write("| c"+str(i)+" ")
        Fout.write(")")


def SerieTestResource2(L,meth) :
        for (n,m,kf,d) in L :
                testResource2(n,m,kf,d,meth)
                
def testResource2(n,m,kf,d,met,ea,solver) :
        def aux(i) :
            ResourceDisj2(kf, Fout)
            Fout.write(" | EX (\n")
            if i==1 :
                ResourceDisj2(kf, Fout)
            else :
                aux(i-1)
            Fout.write(")\n")
        print("*****************************************************")
        print("Model ",str(n),"x",str(m))
        print("Find "+str(kf)+" vertices such that every reachable state can reach in at most "+str(d)+" transitions one of these vertices.")
        print("Method ",met)
        print("-----------------------------------------------------")
        print("Construction of the formula...")
        foutFresource="F"+str(kf)+"_"+str(d)
        if os.path.isfile('MAP2/'+foutFresource) :
                print("The formula already exists.")
#                os.system("rm MAP/"+foutFresource)
        else :
                Fout=open('MAP2/'+foutFresource,'w')
                Fout.write("Ex1 c1")
                for i in range(2,kf+1) :
                   Fout.write(", c"+str(i))
                Fout.write(". AG (")
#                ResourceDisj(kf,Fout)
#                Fout.write("\n")
                aux(d)            
                Fout.write(")\n")
                Fout.close()
#        F=parserF.read_formula('MAP/'+foutFresource)
#        print(F.toString())
        
        foutR="Kres2_"+str(n)+"_"+str(m)
        print("Construction of the model... file:"+"MAP2/"+foutR)
        if os.path.isfile('MAP2/'+foutR) :
                print("The model already exists...")
#                os.system("rm MAP2/"+foutR)
        else :
               K = grilleKS2(n,m) 
               KStoQCTLmodele(K,'MAP2/'+foutR)
        print("-----------------------------------------------------")
        F=main.read_formula('MAP2/'+foutFresource)
        K=Krip.from_file('MAP2/'+foutR,0)
        fichname='MAP2/'+foutR+'_'+str(kf)+"_"+str(d)+'_'+met+'_'+str(ea)
        res=main.Verif(F,K,fichname,met,ea,solver)
        #main.verif(foutR,foutFresource,"MAP/",met)




